/*****************************************************************************
* Copyright (c) 2014 Intelligent Light. All rights reserved.
* Work partially supported by DOE Grant SC0007548.
* FieldView FieldViewXDB Export is provided expressly for use within VisIt.
* All other uses are strictly forbidden.
*****************************************************************************/

// ****************************************************************************
//                               FieldViewXDBPluginInfo.h
// ****************************************************************************

#ifndef FIELDVIEWXDB_PLUGIN_INFO_H
#define FIELDVIEWXDB_PLUGIN_INFO_H
#include <DatabasePluginInfo.h>
#include <database_plugin_exports.h>

class avtDatabase;
class avtDatabaseWriter;

// ****************************************************************************
//  Class: FieldViewXDBDatabasePluginInfo
//
//  Purpose:
//    Classes that provide all the information about the FieldViewXDB plugin.
//    Portions are separated into pieces relevant to the appropriate
//    components of VisIt.
//
//  Programmer: generated by xml2info
//  Creation:   omitted
//
//  Modifications:
//
// ****************************************************************************

class FieldViewXDBGeneralPluginInfo : public virtual GeneralDatabasePluginInfo
{
  public:
    virtual const char *GetName() const;
    virtual const char *GetVersion() const;
    virtual const char *GetID() const;
    virtual bool  EnabledByDefault() const;
    virtual bool  HasWriter() const;
    virtual std::vector<std::string> GetDefaultFilePatterns() const;
    virtual bool  AreDefaultFilePatternsStrict() const;
    virtual bool  OpensWholeDirectory() const;
};

class FieldViewXDBCommonPluginInfo : public virtual CommonDatabasePluginInfo, public virtual FieldViewXDBGeneralPluginInfo
{
  public:
    virtual DatabaseType              GetDatabaseType();
    virtual avtDatabase              *SetupDatabase(const char * const *list,
                                                    int nList, int nBlock);
    virtual std::string               GetLicense() const;
};

class FieldViewXDBMDServerPluginInfo : public virtual MDServerDatabasePluginInfo, public virtual FieldViewXDBCommonPluginInfo
{
  public:
    // this makes compilers happy... remove if we ever have functions here
    virtual void dummy();
};

class FieldViewXDBEnginePluginInfo : public virtual EngineDatabasePluginInfo, public virtual FieldViewXDBCommonPluginInfo
{
  public:
    virtual avtDatabaseWriter        *GetWriter(void);
};

#endif
