// ***************************************************************************
//
// Copyright (c) 2000 - 2014, Lawrence Livermore National Security, LLC
// Produced at the Lawrence Livermore National Laboratory
// LLNL-CODE-442911
// All rights reserved.
//
// This file is  part of VisIt. For  details, see https://visit.llnl.gov/.  The
// full copyright notice is contained in the file COPYRIGHT located at the root
// of the VisIt distribution or at http://www.llnl.gov/visit/copyright.html.
//
// Redistribution  and  use  in  source  and  binary  forms,  with  or  without
// modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of  source code must  retain the above  copyright notice,
//    this list of conditions and the disclaimer below.
//  - Redistributions in binary form must reproduce the above copyright notice,
//    this  list of  conditions  and  the  disclaimer (as noted below)  in  the
//    documentation and/or other materials provided with the distribution.
//  - Neither the name of  the LLNS/LLNL nor the names of  its contributors may
//    be used to endorse or promote products derived from this software without
//    specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT  HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR  IMPLIED WARRANTIES, INCLUDING,  BUT NOT  LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND  FITNESS FOR A PARTICULAR  PURPOSE
// ARE  DISCLAIMED. IN  NO EVENT  SHALL LAWRENCE  LIVERMORE NATIONAL  SECURITY,
// LLC, THE  U.S.  DEPARTMENT OF  ENERGY  OR  CONTRIBUTORS BE  LIABLE  FOR  ANY
// DIRECT,  INDIRECT,   INCIDENTAL,   SPECIAL,   EXEMPLARY,  OR   CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT  LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR
// SERVICES; LOSS OF  USE, DATA, OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER
// CAUSED  AND  ON  ANY  THEORY  OF  LIABILITY,  WHETHER  IN  CONTRACT,  STRICT
// LIABILITY, OR TORT  (INCLUDING NEGLIGENCE OR OTHERWISE)  ARISING IN ANY  WAY
// OUT OF THE  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
// DAMAGE.
//
// ***************************************************************************

package llnl.visit.operators;

import llnl.visit.AttributeSubject;
import llnl.visit.CommunicationBuffer;
import llnl.visit.Plugin;

// ****************************************************************************
// Class: StaggerAttributes
//
// Purpose:
//    This class contains attributes for the stagger operator.
//
// Notes:      Autogenerated by xml2java.
//
// Programmer: xml2java
// Creation:   omitted
//
// Modifications:
//   
// ****************************************************************************

public class StaggerAttributes extends AttributeSubject implements Plugin
{
    private static int StaggerAttributes_numAdditionalAtts = 3;

    public StaggerAttributes()
    {
        super(StaggerAttributes_numAdditionalAtts);

        offsetX = 0;
        offsetY = 0;
        offsetZ = 0;
    }

    public StaggerAttributes(int nMoreFields)
    {
        super(StaggerAttributes_numAdditionalAtts + nMoreFields);

        offsetX = 0;
        offsetY = 0;
        offsetZ = 0;
    }

    public StaggerAttributes(StaggerAttributes obj)
    {
        super(StaggerAttributes_numAdditionalAtts);

        offsetX = obj.offsetX;
        offsetY = obj.offsetY;
        offsetZ = obj.offsetZ;

        SelectAll();
    }

    public int Offset()
    {
        return super.Offset() + super.GetNumAdditionalAttributes();
    }

    public int GetNumAdditionalAttributes()
    {
        return StaggerAttributes_numAdditionalAtts;
    }

    public boolean equals(StaggerAttributes obj)
    {
        // Create the return value
        return ((offsetX == obj.offsetX) &&
                (offsetY == obj.offsetY) &&
                (offsetZ == obj.offsetZ));
    }

    public String GetName() { return "Stagger"; }
    public String GetVersion() { return "1.0"; }

    // Property setting methods
    public void SetOffsetX(double offsetX_)
    {
        offsetX = offsetX_;
        Select(0);
    }

    public void SetOffsetY(double offsetY_)
    {
        offsetY = offsetY_;
        Select(1);
    }

    public void SetOffsetZ(double offsetZ_)
    {
        offsetZ = offsetZ_;
        Select(2);
    }

    // Property getting methods
    public double GetOffsetX() { return offsetX; }
    public double GetOffsetY() { return offsetY; }
    public double GetOffsetZ() { return offsetZ; }

    // Write and read methods.
    public void WriteAtts(CommunicationBuffer buf)
    {
        if(WriteSelect(0, buf))
            buf.WriteDouble(offsetX);
        if(WriteSelect(1, buf))
            buf.WriteDouble(offsetY);
        if(WriteSelect(2, buf))
            buf.WriteDouble(offsetZ);
    }

    public void ReadAtts(int index, CommunicationBuffer buf)
    {
        switch(index)
        {
        case 0:
            SetOffsetX(buf.ReadDouble());
            break;
        case 1:
            SetOffsetY(buf.ReadDouble());
            break;
        case 2:
            SetOffsetZ(buf.ReadDouble());
            break;
        }
    }

    public String toString(String indent)
    {
        String str = new String();
        str = str + doubleToString("offsetX", offsetX, indent) + "\n";
        str = str + doubleToString("offsetY", offsetY, indent) + "\n";
        str = str + doubleToString("offsetZ", offsetZ, indent) + "\n";
        return str;
    }


    // Attributes
    private double offsetX;
    private double offsetY;
    private double offsetZ;
}

