// ***************************************************************************
//
// Copyright (c) 2000 - 2014, Lawrence Livermore National Security, LLC
// Produced at the Lawrence Livermore National Laboratory
// LLNL-CODE-442911
// All rights reserved.
//
// This file is  part of VisIt. For  details, see https://visit.llnl.gov/.  The
// full copyright notice is contained in the file COPYRIGHT located at the root
// of the VisIt distribution or at http://www.llnl.gov/visit/copyright.html.
//
// Redistribution  and  use  in  source  and  binary  forms,  with  or  without
// modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of  source code must  retain the above  copyright notice,
//    this list of conditions and the disclaimer below.
//  - Redistributions in binary form must reproduce the above copyright notice,
//    this  list of  conditions  and  the  disclaimer (as noted below)  in  the
//    documentation and/or other materials provided with the distribution.
//  - Neither the name of  the LLNS/LLNL nor the names of  its contributors may
//    be used to endorse or promote products derived from this software without
//    specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT  HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR  IMPLIED WARRANTIES, INCLUDING,  BUT NOT  LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND  FITNESS FOR A PARTICULAR  PURPOSE
// ARE  DISCLAIMED. IN  NO EVENT  SHALL LAWRENCE  LIVERMORE NATIONAL  SECURITY,
// LLC, THE  U.S.  DEPARTMENT OF  ENERGY  OR  CONTRIBUTORS BE  LIABLE  FOR  ANY
// DIRECT,  INDIRECT,   INCIDENTAL,   SPECIAL,   EXEMPLARY,  OR   CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT  LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR
// SERVICES; LOSS OF  USE, DATA, OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER
// CAUSED  AND  ON  ANY  THEORY  OF  LIABILITY,  WHETHER  IN  CONTRACT,  STRICT
// LIABILITY, OR TORT  (INCLUDING NEGLIGENCE OR OTHERWISE)  ARISING IN ANY  WAY
// OUT OF THE  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
// DAMAGE.
//
// ***************************************************************************

package llnl.visit.plots;

import llnl.visit.AttributeSubject;
import llnl.visit.CommunicationBuffer;
import llnl.visit.Plugin;
import java.lang.Double;
import java.util.Vector;
import llnl.visit.ColorAttribute;

// ****************************************************************************
// Class: StreamlineAttributes
//
// Purpose:
//    Attributes for the Streamline plot
//
// Notes:      Autogenerated by xml2java.
//
// Programmer: xml2java
// Creation:   omitted
//
// Modifications:
//   
// ****************************************************************************

public class StreamlineAttributes extends AttributeSubject implements Plugin
{
    private static int StreamlineAttributes_numAdditionalAtts = 106;

    // Enum values
    public final static int SOURCETYPE_SPECIFIEDPOINT = 0;
    public final static int SOURCETYPE_SPECIFIEDPOINTLIST = 1;
    public final static int SOURCETYPE_SPECIFIEDLINE = 2;
    public final static int SOURCETYPE_SPECIFIEDCIRCLE = 3;
    public final static int SOURCETYPE_SPECIFIEDPLANE = 4;
    public final static int SOURCETYPE_SPECIFIEDSPHERE = 5;
    public final static int SOURCETYPE_SPECIFIEDBOX = 6;
    public final static int SOURCETYPE_SELECTION = 7;

    public final static int COLORINGMETHOD_SOLID = 0;
    public final static int COLORINGMETHOD_COLORBYSPEED = 1;
    public final static int COLORINGMETHOD_COLORBYVORTICITY = 2;
    public final static int COLORINGMETHOD_COLORBYLENGTH = 3;
    public final static int COLORINGMETHOD_COLORBYTIME = 4;
    public final static int COLORINGMETHOD_COLORBYSEEDPOINTID = 5;
    public final static int COLORINGMETHOD_COLORBYVARIABLE = 6;
    public final static int COLORINGMETHOD_COLORBYCORRELATIONDISTANCE = 7;

    public final static int COORDINATESYSTEM_ASIS = 0;
    public final static int COORDINATESYSTEM_CYLINDRICALTOCARTESIAN = 1;
    public final static int COORDINATESYSTEM_CARTESIANTOCYLINDRICAL = 2;

    public final static int DISPLAYMETHOD_LINES = 0;
    public final static int DISPLAYMETHOD_TUBES = 1;
    public final static int DISPLAYMETHOD_RIBBONS = 2;

    public final static int INTEGRATIONDIRECTION_FORWARD = 0;
    public final static int INTEGRATIONDIRECTION_BACKWARD = 1;
    public final static int INTEGRATIONDIRECTION_BOTH = 2;

    public final static int REFERENCETYPE_DISTANCE = 0;
    public final static int REFERENCETYPE_TIME = 1;
    public final static int REFERENCETYPE_STEP = 2;

    public final static int PARALLELIZATIONALGORITHMTYPE_LOADONDEMAND = 0;
    public final static int PARALLELIZATIONALGORITHMTYPE_PARALLELSTATICDOMAINS = 1;
    public final static int PARALLELIZATIONALGORITHMTYPE_MASTERSLAVE = 2;
    public final static int PARALLELIZATIONALGORITHMTYPE_VISITSELECTS = 3;

    public final static int FIELDTYPE_DEFAULT = 0;
    public final static int FIELDTYPE_FLASHFIELD = 1;
    public final static int FIELDTYPE_M3DC12DFIELD = 2;
    public final static int FIELDTYPE_M3DC13DFIELD = 3;
    public final static int FIELDTYPE_NEK5000FIELD = 4;
    public final static int FIELDTYPE_NIMRODFIELD = 5;

    public final static int INTEGRATIONTYPE_EULER = 0;
    public final static int INTEGRATIONTYPE_LEAPFROG = 1;
    public final static int INTEGRATIONTYPE_DORMANDPRINCE = 2;
    public final static int INTEGRATIONTYPE_ADAMSBASHFORTH = 3;
    public final static int INTEGRATIONTYPE_RK4 = 4;
    public final static int INTEGRATIONTYPE_M3DC12DINTEGRATOR = 5;

    public final static int OPACITYTYPE_FULLYOPAQUE = 0;
    public final static int OPACITYTYPE_CONSTANT = 1;
    public final static int OPACITYTYPE_RAMP = 2;
    public final static int OPACITYTYPE_VARIABLERANGE = 3;

    public final static int DISPLAYQUALITY_LOW = 0;
    public final static int DISPLAYQUALITY_MEDIUM = 1;
    public final static int DISPLAYQUALITY_HIGH = 2;
    public final static int DISPLAYQUALITY_SUPER = 3;

    public final static int GEOMDISPLAYTYPE_SPHERE = 0;
    public final static int GEOMDISPLAYTYPE_CONE = 1;

    public final static int SIZETYPE_ABSOLUTE = 0;
    public final static int SIZETYPE_FRACTIONOFBBOX = 1;

    public final static int PATHLINESCMFE_CONN_CMFE = 0;
    public final static int PATHLINESCMFE_POS_CMFE = 1;

    public final static int VARYTUBERADIUSTYPE_NONE = 0;
    public final static int VARYTUBERADIUSTYPE_SCALAR = 1;


    public StreamlineAttributes()
    {
        super(StreamlineAttributes_numAdditionalAtts);

        sourceType = SOURCETYPE_SPECIFIEDPOINT;
        pointSource = new double[3];
        pointSource[0] = 0;
        pointSource[1] = 0;
        pointSource[2] = 0;
        lineStart = new double[3];
        lineStart[0] = 0;
        lineStart[1] = 0;
        lineStart[2] = 0;
        lineEnd = new double[3];
        lineEnd[0] = 1;
        lineEnd[1] = 0;
        lineEnd[2] = 0;
        planeOrigin = new double[3];
        planeOrigin[0] = 0;
        planeOrigin[1] = 0;
        planeOrigin[2] = 0;
        planeNormal = new double[3];
        planeNormal[0] = 0;
        planeNormal[1] = 0;
        planeNormal[2] = 1;
        planeUpAxis = new double[3];
        planeUpAxis[0] = 0;
        planeUpAxis[1] = 1;
        planeUpAxis[2] = 0;
        radius = 1;
        sphereOrigin = new double[3];
        sphereOrigin[0] = 0;
        sphereOrigin[1] = 0;
        sphereOrigin[2] = 0;
        boxExtents = new double[6];
        boxExtents[0] = 0;
        boxExtents[1] = 1;
        boxExtents[2] = 0;
        boxExtents[3] = 1;
        boxExtents[4] = 0;
        boxExtents[5] = 1;
        useWholeBox = true;
        pointList = new Vector();
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(1));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(1));
        pointList.addElement(new Double(0));
        sampleDensity0 = 2;
        sampleDensity1 = 2;
        sampleDensity2 = 2;
        coloringMethod = COLORINGMETHOD_COLORBYTIME;
        colorTableName = new String("Default");
        singleColor = new ColorAttribute(0, 0, 0);
        legendFlag = true;
        lightingFlag = true;
        integrationDirection = INTEGRATIONDIRECTION_FORWARD;
        maxSteps = 1000;
        terminateByDistance = false;
        termDistance = 10;
        terminateByTime = false;
        termTime = 10;
        maxStepLength = 0.1;
        limitMaximumTimestep = false;
        maxTimeStep = 0.1;
        relTol = 0.0001;
        absTolSizeType = SIZETYPE_FRACTIONOFBBOX;
        absTolAbsolute = 1e-06;
        absTolBBox = 1e-06;
        fieldType = FIELDTYPE_DEFAULT;
        fieldConstant = 1;
        velocitySource = new double[3];
        velocitySource[0] = 0;
        velocitySource[1] = 0;
        velocitySource[2] = 0;
        integrationType = INTEGRATIONTYPE_DORMANDPRINCE;
        parallelizationAlgorithmType = PARALLELIZATIONALGORITHMTYPE_VISITSELECTS;
        maxProcessCount = 10;
        maxDomainCacheSize = 3;
        workGroupSize = 32;
        pathlines = false;
        pathlinesOverrideStartingTimeFlag = false;
        pathlinesOverrideStartingTime = 0;
        pathlinesPeriod = 0;
        pathlinesCMFE = PATHLINESCMFE_POS_CMFE;
        coordinateSystem = COORDINATESYSTEM_ASIS;
        phiScalingFlag = false;
        phiScaling = 1;
        coloringVariable = new String("");
        legendMinFlag = false;
        legendMaxFlag = false;
        legendMin = 0;
        legendMax = 1;
        displayBegin = 0;
        displayEnd = 1;
        displayBeginFlag = false;
        displayEndFlag = false;
        referenceTypeForDisplay = REFERENCETYPE_DISTANCE;
        displayMethod = DISPLAYMETHOD_LINES;
        tubeSizeType = SIZETYPE_FRACTIONOFBBOX;
        tubeRadiusAbsolute = 0.125;
        tubeRadiusBBox = 0.005;
        ribbonWidthSizeType = SIZETYPE_FRACTIONOFBBOX;
        ribbonWidthAbsolute = 0.125;
        ribbonWidthBBox = 0.01;
        lineWidth = 2;
        showSeeds = true;
        seedRadiusSizeType = SIZETYPE_FRACTIONOFBBOX;
        seedRadiusAbsolute = 1;
        seedRadiusBBox = 0.015;
        showHeads = false;
        headDisplayType = GEOMDISPLAYTYPE_SPHERE;
        headRadiusSizeType = SIZETYPE_FRACTIONOFBBOX;
        headRadiusAbsolute = 0.25;
        headRadiusBBox = 0.02;
        headHeightRatio = 2;
        opacityType = OPACITYTYPE_FULLYOPAQUE;
        opacityVariable = new String("");
        opacity = 1;
        opacityVarMin = 0;
        opacityVarMax = 1;
        opacityVarMinFlag = false;
        opacityVarMaxFlag = false;
        tubeDisplayDensity = 10;
        geomDisplayQuality = DISPLAYQUALITY_MEDIUM;
        sampleDistance0 = 10;
        sampleDistance1 = 10;
        sampleDistance2 = 10;
        fillInterior = true;
        randomSamples = false;
        randomSeed = 0;
        numberOfRandomSamples = 1;
        forceNodeCenteredData = false;
        issueTerminationWarnings = true;
        issueStiffnessWarnings = true;
        issueCriticalPointsWarnings = true;
        criticalPointThreshold = 0.001;
        varyTubeRadius = VARYTUBERADIUSTYPE_NONE;
        varyTubeRadiusFactor = 10;
        varyTubeRadiusVariable = new String("");
        correlationDistanceAngTol = 5;
        correlationDistanceMinDistAbsolute = 1;
        correlationDistanceMinDistBBox = 0.005;
        correlationDistanceMinDistType = SIZETYPE_FRACTIONOFBBOX;
        selection = new String("");
    }

    public StreamlineAttributes(int nMoreFields)
    {
        super(StreamlineAttributes_numAdditionalAtts + nMoreFields);

        sourceType = SOURCETYPE_SPECIFIEDPOINT;
        pointSource = new double[3];
        pointSource[0] = 0;
        pointSource[1] = 0;
        pointSource[2] = 0;
        lineStart = new double[3];
        lineStart[0] = 0;
        lineStart[1] = 0;
        lineStart[2] = 0;
        lineEnd = new double[3];
        lineEnd[0] = 1;
        lineEnd[1] = 0;
        lineEnd[2] = 0;
        planeOrigin = new double[3];
        planeOrigin[0] = 0;
        planeOrigin[1] = 0;
        planeOrigin[2] = 0;
        planeNormal = new double[3];
        planeNormal[0] = 0;
        planeNormal[1] = 0;
        planeNormal[2] = 1;
        planeUpAxis = new double[3];
        planeUpAxis[0] = 0;
        planeUpAxis[1] = 1;
        planeUpAxis[2] = 0;
        radius = 1;
        sphereOrigin = new double[3];
        sphereOrigin[0] = 0;
        sphereOrigin[1] = 0;
        sphereOrigin[2] = 0;
        boxExtents = new double[6];
        boxExtents[0] = 0;
        boxExtents[1] = 1;
        boxExtents[2] = 0;
        boxExtents[3] = 1;
        boxExtents[4] = 0;
        boxExtents[5] = 1;
        useWholeBox = true;
        pointList = new Vector();
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(1));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(0));
        pointList.addElement(new Double(1));
        pointList.addElement(new Double(0));
        sampleDensity0 = 2;
        sampleDensity1 = 2;
        sampleDensity2 = 2;
        coloringMethod = COLORINGMETHOD_COLORBYTIME;
        colorTableName = new String("Default");
        singleColor = new ColorAttribute(0, 0, 0);
        legendFlag = true;
        lightingFlag = true;
        integrationDirection = INTEGRATIONDIRECTION_FORWARD;
        maxSteps = 1000;
        terminateByDistance = false;
        termDistance = 10;
        terminateByTime = false;
        termTime = 10;
        maxStepLength = 0.1;
        limitMaximumTimestep = false;
        maxTimeStep = 0.1;
        relTol = 0.0001;
        absTolSizeType = SIZETYPE_FRACTIONOFBBOX;
        absTolAbsolute = 1e-06;
        absTolBBox = 1e-06;
        fieldType = FIELDTYPE_DEFAULT;
        fieldConstant = 1;
        velocitySource = new double[3];
        velocitySource[0] = 0;
        velocitySource[1] = 0;
        velocitySource[2] = 0;
        integrationType = INTEGRATIONTYPE_DORMANDPRINCE;
        parallelizationAlgorithmType = PARALLELIZATIONALGORITHMTYPE_VISITSELECTS;
        maxProcessCount = 10;
        maxDomainCacheSize = 3;
        workGroupSize = 32;
        pathlines = false;
        pathlinesOverrideStartingTimeFlag = false;
        pathlinesOverrideStartingTime = 0;
        pathlinesPeriod = 0;
        pathlinesCMFE = PATHLINESCMFE_POS_CMFE;
        coordinateSystem = COORDINATESYSTEM_ASIS;
        phiScalingFlag = false;
        phiScaling = 1;
        coloringVariable = new String("");
        legendMinFlag = false;
        legendMaxFlag = false;
        legendMin = 0;
        legendMax = 1;
        displayBegin = 0;
        displayEnd = 1;
        displayBeginFlag = false;
        displayEndFlag = false;
        referenceTypeForDisplay = REFERENCETYPE_DISTANCE;
        displayMethod = DISPLAYMETHOD_LINES;
        tubeSizeType = SIZETYPE_FRACTIONOFBBOX;
        tubeRadiusAbsolute = 0.125;
        tubeRadiusBBox = 0.005;
        ribbonWidthSizeType = SIZETYPE_FRACTIONOFBBOX;
        ribbonWidthAbsolute = 0.125;
        ribbonWidthBBox = 0.01;
        lineWidth = 2;
        showSeeds = true;
        seedRadiusSizeType = SIZETYPE_FRACTIONOFBBOX;
        seedRadiusAbsolute = 1;
        seedRadiusBBox = 0.015;
        showHeads = false;
        headDisplayType = GEOMDISPLAYTYPE_SPHERE;
        headRadiusSizeType = SIZETYPE_FRACTIONOFBBOX;
        headRadiusAbsolute = 0.25;
        headRadiusBBox = 0.02;
        headHeightRatio = 2;
        opacityType = OPACITYTYPE_FULLYOPAQUE;
        opacityVariable = new String("");
        opacity = 1;
        opacityVarMin = 0;
        opacityVarMax = 1;
        opacityVarMinFlag = false;
        opacityVarMaxFlag = false;
        tubeDisplayDensity = 10;
        geomDisplayQuality = DISPLAYQUALITY_MEDIUM;
        sampleDistance0 = 10;
        sampleDistance1 = 10;
        sampleDistance2 = 10;
        fillInterior = true;
        randomSamples = false;
        randomSeed = 0;
        numberOfRandomSamples = 1;
        forceNodeCenteredData = false;
        issueTerminationWarnings = true;
        issueStiffnessWarnings = true;
        issueCriticalPointsWarnings = true;
        criticalPointThreshold = 0.001;
        varyTubeRadius = VARYTUBERADIUSTYPE_NONE;
        varyTubeRadiusFactor = 10;
        varyTubeRadiusVariable = new String("");
        correlationDistanceAngTol = 5;
        correlationDistanceMinDistAbsolute = 1;
        correlationDistanceMinDistBBox = 0.005;
        correlationDistanceMinDistType = SIZETYPE_FRACTIONOFBBOX;
        selection = new String("");
    }

    public StreamlineAttributes(StreamlineAttributes obj)
    {
        super(StreamlineAttributes_numAdditionalAtts);

        int i;

        sourceType = obj.sourceType;
        pointSource = new double[3];
        pointSource[0] = obj.pointSource[0];
        pointSource[1] = obj.pointSource[1];
        pointSource[2] = obj.pointSource[2];

        lineStart = new double[3];
        lineStart[0] = obj.lineStart[0];
        lineStart[1] = obj.lineStart[1];
        lineStart[2] = obj.lineStart[2];

        lineEnd = new double[3];
        lineEnd[0] = obj.lineEnd[0];
        lineEnd[1] = obj.lineEnd[1];
        lineEnd[2] = obj.lineEnd[2];

        planeOrigin = new double[3];
        planeOrigin[0] = obj.planeOrigin[0];
        planeOrigin[1] = obj.planeOrigin[1];
        planeOrigin[2] = obj.planeOrigin[2];

        planeNormal = new double[3];
        planeNormal[0] = obj.planeNormal[0];
        planeNormal[1] = obj.planeNormal[1];
        planeNormal[2] = obj.planeNormal[2];

        planeUpAxis = new double[3];
        planeUpAxis[0] = obj.planeUpAxis[0];
        planeUpAxis[1] = obj.planeUpAxis[1];
        planeUpAxis[2] = obj.planeUpAxis[2];

        radius = obj.radius;
        sphereOrigin = new double[3];
        sphereOrigin[0] = obj.sphereOrigin[0];
        sphereOrigin[1] = obj.sphereOrigin[1];
        sphereOrigin[2] = obj.sphereOrigin[2];

        boxExtents = new double[6];
        for(i = 0; i < obj.boxExtents.length; ++i)
            boxExtents[i] = obj.boxExtents[i];

        useWholeBox = obj.useWholeBox;
        pointList = new Vector(obj.pointList.size());
        for(i = 0; i < obj.pointList.size(); ++i)
        {
            Double dv = (Double)obj.pointList.elementAt(i);
            pointList.addElement(new Double(dv.doubleValue()));
        }

        sampleDensity0 = obj.sampleDensity0;
        sampleDensity1 = obj.sampleDensity1;
        sampleDensity2 = obj.sampleDensity2;
        coloringMethod = obj.coloringMethod;
        colorTableName = new String(obj.colorTableName);
        singleColor = new ColorAttribute(obj.singleColor);
        legendFlag = obj.legendFlag;
        lightingFlag = obj.lightingFlag;
        integrationDirection = obj.integrationDirection;
        maxSteps = obj.maxSteps;
        terminateByDistance = obj.terminateByDistance;
        termDistance = obj.termDistance;
        terminateByTime = obj.terminateByTime;
        termTime = obj.termTime;
        maxStepLength = obj.maxStepLength;
        limitMaximumTimestep = obj.limitMaximumTimestep;
        maxTimeStep = obj.maxTimeStep;
        relTol = obj.relTol;
        absTolSizeType = obj.absTolSizeType;
        absTolAbsolute = obj.absTolAbsolute;
        absTolBBox = obj.absTolBBox;
        fieldType = obj.fieldType;
        fieldConstant = obj.fieldConstant;
        velocitySource = new double[3];
        velocitySource[0] = obj.velocitySource[0];
        velocitySource[1] = obj.velocitySource[1];
        velocitySource[2] = obj.velocitySource[2];

        integrationType = obj.integrationType;
        parallelizationAlgorithmType = obj.parallelizationAlgorithmType;
        maxProcessCount = obj.maxProcessCount;
        maxDomainCacheSize = obj.maxDomainCacheSize;
        workGroupSize = obj.workGroupSize;
        pathlines = obj.pathlines;
        pathlinesOverrideStartingTimeFlag = obj.pathlinesOverrideStartingTimeFlag;
        pathlinesOverrideStartingTime = obj.pathlinesOverrideStartingTime;
        pathlinesPeriod = obj.pathlinesPeriod;
        pathlinesCMFE = obj.pathlinesCMFE;
        coordinateSystem = obj.coordinateSystem;
        phiScalingFlag = obj.phiScalingFlag;
        phiScaling = obj.phiScaling;
        coloringVariable = new String(obj.coloringVariable);
        legendMinFlag = obj.legendMinFlag;
        legendMaxFlag = obj.legendMaxFlag;
        legendMin = obj.legendMin;
        legendMax = obj.legendMax;
        displayBegin = obj.displayBegin;
        displayEnd = obj.displayEnd;
        displayBeginFlag = obj.displayBeginFlag;
        displayEndFlag = obj.displayEndFlag;
        referenceTypeForDisplay = obj.referenceTypeForDisplay;
        displayMethod = obj.displayMethod;
        tubeSizeType = obj.tubeSizeType;
        tubeRadiusAbsolute = obj.tubeRadiusAbsolute;
        tubeRadiusBBox = obj.tubeRadiusBBox;
        ribbonWidthSizeType = obj.ribbonWidthSizeType;
        ribbonWidthAbsolute = obj.ribbonWidthAbsolute;
        ribbonWidthBBox = obj.ribbonWidthBBox;
        lineWidth = obj.lineWidth;
        showSeeds = obj.showSeeds;
        seedRadiusSizeType = obj.seedRadiusSizeType;
        seedRadiusAbsolute = obj.seedRadiusAbsolute;
        seedRadiusBBox = obj.seedRadiusBBox;
        showHeads = obj.showHeads;
        headDisplayType = obj.headDisplayType;
        headRadiusSizeType = obj.headRadiusSizeType;
        headRadiusAbsolute = obj.headRadiusAbsolute;
        headRadiusBBox = obj.headRadiusBBox;
        headHeightRatio = obj.headHeightRatio;
        opacityType = obj.opacityType;
        opacityVariable = new String(obj.opacityVariable);
        opacity = obj.opacity;
        opacityVarMin = obj.opacityVarMin;
        opacityVarMax = obj.opacityVarMax;
        opacityVarMinFlag = obj.opacityVarMinFlag;
        opacityVarMaxFlag = obj.opacityVarMaxFlag;
        tubeDisplayDensity = obj.tubeDisplayDensity;
        geomDisplayQuality = obj.geomDisplayQuality;
        sampleDistance0 = obj.sampleDistance0;
        sampleDistance1 = obj.sampleDistance1;
        sampleDistance2 = obj.sampleDistance2;
        fillInterior = obj.fillInterior;
        randomSamples = obj.randomSamples;
        randomSeed = obj.randomSeed;
        numberOfRandomSamples = obj.numberOfRandomSamples;
        forceNodeCenteredData = obj.forceNodeCenteredData;
        issueTerminationWarnings = obj.issueTerminationWarnings;
        issueStiffnessWarnings = obj.issueStiffnessWarnings;
        issueCriticalPointsWarnings = obj.issueCriticalPointsWarnings;
        criticalPointThreshold = obj.criticalPointThreshold;
        varyTubeRadius = obj.varyTubeRadius;
        varyTubeRadiusFactor = obj.varyTubeRadiusFactor;
        varyTubeRadiusVariable = new String(obj.varyTubeRadiusVariable);
        correlationDistanceAngTol = obj.correlationDistanceAngTol;
        correlationDistanceMinDistAbsolute = obj.correlationDistanceMinDistAbsolute;
        correlationDistanceMinDistBBox = obj.correlationDistanceMinDistBBox;
        correlationDistanceMinDistType = obj.correlationDistanceMinDistType;
        selection = new String(obj.selection);

        SelectAll();
    }

    public int Offset()
    {
        return super.Offset() + super.GetNumAdditionalAttributes();
    }

    public int GetNumAdditionalAttributes()
    {
        return StreamlineAttributes_numAdditionalAtts;
    }

    public boolean equals(StreamlineAttributes obj)
    {
        int i;

        // Compare the pointSource arrays.
        boolean pointSource_equal = true;
        for(i = 0; i < 3 && pointSource_equal; ++i)
            pointSource_equal = (pointSource[i] == obj.pointSource[i]);

        // Compare the lineStart arrays.
        boolean lineStart_equal = true;
        for(i = 0; i < 3 && lineStart_equal; ++i)
            lineStart_equal = (lineStart[i] == obj.lineStart[i]);

        // Compare the lineEnd arrays.
        boolean lineEnd_equal = true;
        for(i = 0; i < 3 && lineEnd_equal; ++i)
            lineEnd_equal = (lineEnd[i] == obj.lineEnd[i]);

        // Compare the planeOrigin arrays.
        boolean planeOrigin_equal = true;
        for(i = 0; i < 3 && planeOrigin_equal; ++i)
            planeOrigin_equal = (planeOrigin[i] == obj.planeOrigin[i]);

        // Compare the planeNormal arrays.
        boolean planeNormal_equal = true;
        for(i = 0; i < 3 && planeNormal_equal; ++i)
            planeNormal_equal = (planeNormal[i] == obj.planeNormal[i]);

        // Compare the planeUpAxis arrays.
        boolean planeUpAxis_equal = true;
        for(i = 0; i < 3 && planeUpAxis_equal; ++i)
            planeUpAxis_equal = (planeUpAxis[i] == obj.planeUpAxis[i]);

        // Compare the sphereOrigin arrays.
        boolean sphereOrigin_equal = true;
        for(i = 0; i < 3 && sphereOrigin_equal; ++i)
            sphereOrigin_equal = (sphereOrigin[i] == obj.sphereOrigin[i]);

        // Compare the boxExtents arrays.
        boolean boxExtents_equal = true;
        for(i = 0; i < 6 && boxExtents_equal; ++i)
            boxExtents_equal = (boxExtents[i] == obj.boxExtents[i]);

        // Compare the elements in the pointList vector.
        boolean pointList_equal = (obj.pointList.size() == pointList.size());
        for(i = 0; (i < pointList.size()) && pointList_equal; ++i)
        {
            // Make references to Double from Object.
            Double pointList1 = (Double)pointList.elementAt(i);
            Double pointList2 = (Double)obj.pointList.elementAt(i);
            pointList_equal = pointList1.equals(pointList2);
        }
        // Compare the velocitySource arrays.
        boolean velocitySource_equal = true;
        for(i = 0; i < 3 && velocitySource_equal; ++i)
            velocitySource_equal = (velocitySource[i] == obj.velocitySource[i]);

        // Create the return value
        return ((sourceType == obj.sourceType) &&
                pointSource_equal &&
                lineStart_equal &&
                lineEnd_equal &&
                planeOrigin_equal &&
                planeNormal_equal &&
                planeUpAxis_equal &&
                (radius == obj.radius) &&
                sphereOrigin_equal &&
                boxExtents_equal &&
                (useWholeBox == obj.useWholeBox) &&
                pointList_equal &&
                (sampleDensity0 == obj.sampleDensity0) &&
                (sampleDensity1 == obj.sampleDensity1) &&
                (sampleDensity2 == obj.sampleDensity2) &&
                (coloringMethod == obj.coloringMethod) &&
                (colorTableName.equals(obj.colorTableName)) &&
                (singleColor == obj.singleColor) &&
                (legendFlag == obj.legendFlag) &&
                (lightingFlag == obj.lightingFlag) &&
                (integrationDirection == obj.integrationDirection) &&
                (maxSteps == obj.maxSteps) &&
                (terminateByDistance == obj.terminateByDistance) &&
                (termDistance == obj.termDistance) &&
                (terminateByTime == obj.terminateByTime) &&
                (termTime == obj.termTime) &&
                (maxStepLength == obj.maxStepLength) &&
                (limitMaximumTimestep == obj.limitMaximumTimestep) &&
                (maxTimeStep == obj.maxTimeStep) &&
                (relTol == obj.relTol) &&
                (absTolSizeType == obj.absTolSizeType) &&
                (absTolAbsolute == obj.absTolAbsolute) &&
                (absTolBBox == obj.absTolBBox) &&
                (fieldType == obj.fieldType) &&
                (fieldConstant == obj.fieldConstant) &&
                velocitySource_equal &&
                (integrationType == obj.integrationType) &&
                (parallelizationAlgorithmType == obj.parallelizationAlgorithmType) &&
                (maxProcessCount == obj.maxProcessCount) &&
                (maxDomainCacheSize == obj.maxDomainCacheSize) &&
                (workGroupSize == obj.workGroupSize) &&
                (pathlines == obj.pathlines) &&
                (pathlinesOverrideStartingTimeFlag == obj.pathlinesOverrideStartingTimeFlag) &&
                (pathlinesOverrideStartingTime == obj.pathlinesOverrideStartingTime) &&
                (pathlinesPeriod == obj.pathlinesPeriod) &&
                (pathlinesCMFE == obj.pathlinesCMFE) &&
                (coordinateSystem == obj.coordinateSystem) &&
                (phiScalingFlag == obj.phiScalingFlag) &&
                (phiScaling == obj.phiScaling) &&
                (coloringVariable.equals(obj.coloringVariable)) &&
                (legendMinFlag == obj.legendMinFlag) &&
                (legendMaxFlag == obj.legendMaxFlag) &&
                (legendMin == obj.legendMin) &&
                (legendMax == obj.legendMax) &&
                (displayBegin == obj.displayBegin) &&
                (displayEnd == obj.displayEnd) &&
                (displayBeginFlag == obj.displayBeginFlag) &&
                (displayEndFlag == obj.displayEndFlag) &&
                (referenceTypeForDisplay == obj.referenceTypeForDisplay) &&
                (displayMethod == obj.displayMethod) &&
                (tubeSizeType == obj.tubeSizeType) &&
                (tubeRadiusAbsolute == obj.tubeRadiusAbsolute) &&
                (tubeRadiusBBox == obj.tubeRadiusBBox) &&
                (ribbonWidthSizeType == obj.ribbonWidthSizeType) &&
                (ribbonWidthAbsolute == obj.ribbonWidthAbsolute) &&
                (ribbonWidthBBox == obj.ribbonWidthBBox) &&
                (lineWidth == obj.lineWidth) &&
                (showSeeds == obj.showSeeds) &&
                (seedRadiusSizeType == obj.seedRadiusSizeType) &&
                (seedRadiusAbsolute == obj.seedRadiusAbsolute) &&
                (seedRadiusBBox == obj.seedRadiusBBox) &&
                (showHeads == obj.showHeads) &&
                (headDisplayType == obj.headDisplayType) &&
                (headRadiusSizeType == obj.headRadiusSizeType) &&
                (headRadiusAbsolute == obj.headRadiusAbsolute) &&
                (headRadiusBBox == obj.headRadiusBBox) &&
                (headHeightRatio == obj.headHeightRatio) &&
                (opacityType == obj.opacityType) &&
                (opacityVariable.equals(obj.opacityVariable)) &&
                (opacity == obj.opacity) &&
                (opacityVarMin == obj.opacityVarMin) &&
                (opacityVarMax == obj.opacityVarMax) &&
                (opacityVarMinFlag == obj.opacityVarMinFlag) &&
                (opacityVarMaxFlag == obj.opacityVarMaxFlag) &&
                (tubeDisplayDensity == obj.tubeDisplayDensity) &&
                (geomDisplayQuality == obj.geomDisplayQuality) &&
                (sampleDistance0 == obj.sampleDistance0) &&
                (sampleDistance1 == obj.sampleDistance1) &&
                (sampleDistance2 == obj.sampleDistance2) &&
                (fillInterior == obj.fillInterior) &&
                (randomSamples == obj.randomSamples) &&
                (randomSeed == obj.randomSeed) &&
                (numberOfRandomSamples == obj.numberOfRandomSamples) &&
                (forceNodeCenteredData == obj.forceNodeCenteredData) &&
                (issueTerminationWarnings == obj.issueTerminationWarnings) &&
                (issueStiffnessWarnings == obj.issueStiffnessWarnings) &&
                (issueCriticalPointsWarnings == obj.issueCriticalPointsWarnings) &&
                (criticalPointThreshold == obj.criticalPointThreshold) &&
                (varyTubeRadius == obj.varyTubeRadius) &&
                (varyTubeRadiusFactor == obj.varyTubeRadiusFactor) &&
                (varyTubeRadiusVariable.equals(obj.varyTubeRadiusVariable)) &&
                (correlationDistanceAngTol == obj.correlationDistanceAngTol) &&
                (correlationDistanceMinDistAbsolute == obj.correlationDistanceMinDistAbsolute) &&
                (correlationDistanceMinDistBBox == obj.correlationDistanceMinDistBBox) &&
                (correlationDistanceMinDistType == obj.correlationDistanceMinDistType) &&
                (selection.equals(obj.selection)));
    }

    public String GetName() { return "Streamline"; }
    public String GetVersion() { return "1.0"; }

    // Property setting methods
    public void SetSourceType(int sourceType_)
    {
        sourceType = sourceType_;
        Select(0);
    }

    public void SetPointSource(double[] pointSource_)
    {
        pointSource[0] = pointSource_[0];
        pointSource[1] = pointSource_[1];
        pointSource[2] = pointSource_[2];
        Select(1);
    }

    public void SetPointSource(double e0, double e1, double e2)
    {
        pointSource[0] = e0;
        pointSource[1] = e1;
        pointSource[2] = e2;
        Select(1);
    }

    public void SetLineStart(double[] lineStart_)
    {
        lineStart[0] = lineStart_[0];
        lineStart[1] = lineStart_[1];
        lineStart[2] = lineStart_[2];
        Select(2);
    }

    public void SetLineStart(double e0, double e1, double e2)
    {
        lineStart[0] = e0;
        lineStart[1] = e1;
        lineStart[2] = e2;
        Select(2);
    }

    public void SetLineEnd(double[] lineEnd_)
    {
        lineEnd[0] = lineEnd_[0];
        lineEnd[1] = lineEnd_[1];
        lineEnd[2] = lineEnd_[2];
        Select(3);
    }

    public void SetLineEnd(double e0, double e1, double e2)
    {
        lineEnd[0] = e0;
        lineEnd[1] = e1;
        lineEnd[2] = e2;
        Select(3);
    }

    public void SetPlaneOrigin(double[] planeOrigin_)
    {
        planeOrigin[0] = planeOrigin_[0];
        planeOrigin[1] = planeOrigin_[1];
        planeOrigin[2] = planeOrigin_[2];
        Select(4);
    }

    public void SetPlaneOrigin(double e0, double e1, double e2)
    {
        planeOrigin[0] = e0;
        planeOrigin[1] = e1;
        planeOrigin[2] = e2;
        Select(4);
    }

    public void SetPlaneNormal(double[] planeNormal_)
    {
        planeNormal[0] = planeNormal_[0];
        planeNormal[1] = planeNormal_[1];
        planeNormal[2] = planeNormal_[2];
        Select(5);
    }

    public void SetPlaneNormal(double e0, double e1, double e2)
    {
        planeNormal[0] = e0;
        planeNormal[1] = e1;
        planeNormal[2] = e2;
        Select(5);
    }

    public void SetPlaneUpAxis(double[] planeUpAxis_)
    {
        planeUpAxis[0] = planeUpAxis_[0];
        planeUpAxis[1] = planeUpAxis_[1];
        planeUpAxis[2] = planeUpAxis_[2];
        Select(6);
    }

    public void SetPlaneUpAxis(double e0, double e1, double e2)
    {
        planeUpAxis[0] = e0;
        planeUpAxis[1] = e1;
        planeUpAxis[2] = e2;
        Select(6);
    }

    public void SetRadius(double radius_)
    {
        radius = radius_;
        Select(7);
    }

    public void SetSphereOrigin(double[] sphereOrigin_)
    {
        sphereOrigin[0] = sphereOrigin_[0];
        sphereOrigin[1] = sphereOrigin_[1];
        sphereOrigin[2] = sphereOrigin_[2];
        Select(8);
    }

    public void SetSphereOrigin(double e0, double e1, double e2)
    {
        sphereOrigin[0] = e0;
        sphereOrigin[1] = e1;
        sphereOrigin[2] = e2;
        Select(8);
    }

    public void SetBoxExtents(double[] boxExtents_)
    {
        for(int i = 0; i < 6; ++i)
             boxExtents[i] = boxExtents_[i];
        Select(9);
    }

    public void SetUseWholeBox(boolean useWholeBox_)
    {
        useWholeBox = useWholeBox_;
        Select(10);
    }

    public void SetPointList(Vector pointList_)
    {
        pointList = pointList_;
        Select(11);
    }

    public void SetSampleDensity0(int sampleDensity0_)
    {
        sampleDensity0 = sampleDensity0_;
        Select(12);
    }

    public void SetSampleDensity1(int sampleDensity1_)
    {
        sampleDensity1 = sampleDensity1_;
        Select(13);
    }

    public void SetSampleDensity2(int sampleDensity2_)
    {
        sampleDensity2 = sampleDensity2_;
        Select(14);
    }

    public void SetColoringMethod(int coloringMethod_)
    {
        coloringMethod = coloringMethod_;
        Select(15);
    }

    public void SetColorTableName(String colorTableName_)
    {
        colorTableName = colorTableName_;
        Select(16);
    }

    public void SetSingleColor(ColorAttribute singleColor_)
    {
        singleColor = singleColor_;
        Select(17);
    }

    public void SetLegendFlag(boolean legendFlag_)
    {
        legendFlag = legendFlag_;
        Select(18);
    }

    public void SetLightingFlag(boolean lightingFlag_)
    {
        lightingFlag = lightingFlag_;
        Select(19);
    }

    public void SetIntegrationDirection(int integrationDirection_)
    {
        integrationDirection = integrationDirection_;
        Select(20);
    }

    public void SetMaxSteps(int maxSteps_)
    {
        maxSteps = maxSteps_;
        Select(21);
    }

    public void SetTerminateByDistance(boolean terminateByDistance_)
    {
        terminateByDistance = terminateByDistance_;
        Select(22);
    }

    public void SetTermDistance(double termDistance_)
    {
        termDistance = termDistance_;
        Select(23);
    }

    public void SetTerminateByTime(boolean terminateByTime_)
    {
        terminateByTime = terminateByTime_;
        Select(24);
    }

    public void SetTermTime(double termTime_)
    {
        termTime = termTime_;
        Select(25);
    }

    public void SetMaxStepLength(double maxStepLength_)
    {
        maxStepLength = maxStepLength_;
        Select(26);
    }

    public void SetLimitMaximumTimestep(boolean limitMaximumTimestep_)
    {
        limitMaximumTimestep = limitMaximumTimestep_;
        Select(27);
    }

    public void SetMaxTimeStep(double maxTimeStep_)
    {
        maxTimeStep = maxTimeStep_;
        Select(28);
    }

    public void SetRelTol(double relTol_)
    {
        relTol = relTol_;
        Select(29);
    }

    public void SetAbsTolSizeType(int absTolSizeType_)
    {
        absTolSizeType = absTolSizeType_;
        Select(30);
    }

    public void SetAbsTolAbsolute(double absTolAbsolute_)
    {
        absTolAbsolute = absTolAbsolute_;
        Select(31);
    }

    public void SetAbsTolBBox(double absTolBBox_)
    {
        absTolBBox = absTolBBox_;
        Select(32);
    }

    public void SetFieldType(int fieldType_)
    {
        fieldType = fieldType_;
        Select(33);
    }

    public void SetFieldConstant(double fieldConstant_)
    {
        fieldConstant = fieldConstant_;
        Select(34);
    }

    public void SetVelocitySource(double[] velocitySource_)
    {
        velocitySource[0] = velocitySource_[0];
        velocitySource[1] = velocitySource_[1];
        velocitySource[2] = velocitySource_[2];
        Select(35);
    }

    public void SetVelocitySource(double e0, double e1, double e2)
    {
        velocitySource[0] = e0;
        velocitySource[1] = e1;
        velocitySource[2] = e2;
        Select(35);
    }

    public void SetIntegrationType(int integrationType_)
    {
        integrationType = integrationType_;
        Select(36);
    }

    public void SetParallelizationAlgorithmType(int parallelizationAlgorithmType_)
    {
        parallelizationAlgorithmType = parallelizationAlgorithmType_;
        Select(37);
    }

    public void SetMaxProcessCount(int maxProcessCount_)
    {
        maxProcessCount = maxProcessCount_;
        Select(38);
    }

    public void SetMaxDomainCacheSize(int maxDomainCacheSize_)
    {
        maxDomainCacheSize = maxDomainCacheSize_;
        Select(39);
    }

    public void SetWorkGroupSize(int workGroupSize_)
    {
        workGroupSize = workGroupSize_;
        Select(40);
    }

    public void SetPathlines(boolean pathlines_)
    {
        pathlines = pathlines_;
        Select(41);
    }

    public void SetPathlinesOverrideStartingTimeFlag(boolean pathlinesOverrideStartingTimeFlag_)
    {
        pathlinesOverrideStartingTimeFlag = pathlinesOverrideStartingTimeFlag_;
        Select(42);
    }

    public void SetPathlinesOverrideStartingTime(double pathlinesOverrideStartingTime_)
    {
        pathlinesOverrideStartingTime = pathlinesOverrideStartingTime_;
        Select(43);
    }

    public void SetPathlinesPeriod(double pathlinesPeriod_)
    {
        pathlinesPeriod = pathlinesPeriod_;
        Select(44);
    }

    public void SetPathlinesCMFE(int pathlinesCMFE_)
    {
        pathlinesCMFE = pathlinesCMFE_;
        Select(45);
    }

    public void SetCoordinateSystem(int coordinateSystem_)
    {
        coordinateSystem = coordinateSystem_;
        Select(46);
    }

    public void SetPhiScalingFlag(boolean phiScalingFlag_)
    {
        phiScalingFlag = phiScalingFlag_;
        Select(47);
    }

    public void SetPhiScaling(double phiScaling_)
    {
        phiScaling = phiScaling_;
        Select(48);
    }

    public void SetColoringVariable(String coloringVariable_)
    {
        coloringVariable = coloringVariable_;
        Select(49);
    }

    public void SetLegendMinFlag(boolean legendMinFlag_)
    {
        legendMinFlag = legendMinFlag_;
        Select(50);
    }

    public void SetLegendMaxFlag(boolean legendMaxFlag_)
    {
        legendMaxFlag = legendMaxFlag_;
        Select(51);
    }

    public void SetLegendMin(double legendMin_)
    {
        legendMin = legendMin_;
        Select(52);
    }

    public void SetLegendMax(double legendMax_)
    {
        legendMax = legendMax_;
        Select(53);
    }

    public void SetDisplayBegin(double displayBegin_)
    {
        displayBegin = displayBegin_;
        Select(54);
    }

    public void SetDisplayEnd(double displayEnd_)
    {
        displayEnd = displayEnd_;
        Select(55);
    }

    public void SetDisplayBeginFlag(boolean displayBeginFlag_)
    {
        displayBeginFlag = displayBeginFlag_;
        Select(56);
    }

    public void SetDisplayEndFlag(boolean displayEndFlag_)
    {
        displayEndFlag = displayEndFlag_;
        Select(57);
    }

    public void SetReferenceTypeForDisplay(int referenceTypeForDisplay_)
    {
        referenceTypeForDisplay = referenceTypeForDisplay_;
        Select(58);
    }

    public void SetDisplayMethod(int displayMethod_)
    {
        displayMethod = displayMethod_;
        Select(59);
    }

    public void SetTubeSizeType(int tubeSizeType_)
    {
        tubeSizeType = tubeSizeType_;
        Select(60);
    }

    public void SetTubeRadiusAbsolute(double tubeRadiusAbsolute_)
    {
        tubeRadiusAbsolute = tubeRadiusAbsolute_;
        Select(61);
    }

    public void SetTubeRadiusBBox(double tubeRadiusBBox_)
    {
        tubeRadiusBBox = tubeRadiusBBox_;
        Select(62);
    }

    public void SetRibbonWidthSizeType(int ribbonWidthSizeType_)
    {
        ribbonWidthSizeType = ribbonWidthSizeType_;
        Select(63);
    }

    public void SetRibbonWidthAbsolute(double ribbonWidthAbsolute_)
    {
        ribbonWidthAbsolute = ribbonWidthAbsolute_;
        Select(64);
    }

    public void SetRibbonWidthBBox(double ribbonWidthBBox_)
    {
        ribbonWidthBBox = ribbonWidthBBox_;
        Select(65);
    }

    public void SetLineWidth(int lineWidth_)
    {
        lineWidth = lineWidth_;
        Select(66);
    }

    public void SetShowSeeds(boolean showSeeds_)
    {
        showSeeds = showSeeds_;
        Select(67);
    }

    public void SetSeedRadiusSizeType(int seedRadiusSizeType_)
    {
        seedRadiusSizeType = seedRadiusSizeType_;
        Select(68);
    }

    public void SetSeedRadiusAbsolute(double seedRadiusAbsolute_)
    {
        seedRadiusAbsolute = seedRadiusAbsolute_;
        Select(69);
    }

    public void SetSeedRadiusBBox(double seedRadiusBBox_)
    {
        seedRadiusBBox = seedRadiusBBox_;
        Select(70);
    }

    public void SetShowHeads(boolean showHeads_)
    {
        showHeads = showHeads_;
        Select(71);
    }

    public void SetHeadDisplayType(int headDisplayType_)
    {
        headDisplayType = headDisplayType_;
        Select(72);
    }

    public void SetHeadRadiusSizeType(int headRadiusSizeType_)
    {
        headRadiusSizeType = headRadiusSizeType_;
        Select(73);
    }

    public void SetHeadRadiusAbsolute(double headRadiusAbsolute_)
    {
        headRadiusAbsolute = headRadiusAbsolute_;
        Select(74);
    }

    public void SetHeadRadiusBBox(double headRadiusBBox_)
    {
        headRadiusBBox = headRadiusBBox_;
        Select(75);
    }

    public void SetHeadHeightRatio(double headHeightRatio_)
    {
        headHeightRatio = headHeightRatio_;
        Select(76);
    }

    public void SetOpacityType(int opacityType_)
    {
        opacityType = opacityType_;
        Select(77);
    }

    public void SetOpacityVariable(String opacityVariable_)
    {
        opacityVariable = opacityVariable_;
        Select(78);
    }

    public void SetOpacity(double opacity_)
    {
        opacity = opacity_;
        Select(79);
    }

    public void SetOpacityVarMin(double opacityVarMin_)
    {
        opacityVarMin = opacityVarMin_;
        Select(80);
    }

    public void SetOpacityVarMax(double opacityVarMax_)
    {
        opacityVarMax = opacityVarMax_;
        Select(81);
    }

    public void SetOpacityVarMinFlag(boolean opacityVarMinFlag_)
    {
        opacityVarMinFlag = opacityVarMinFlag_;
        Select(82);
    }

    public void SetOpacityVarMaxFlag(boolean opacityVarMaxFlag_)
    {
        opacityVarMaxFlag = opacityVarMaxFlag_;
        Select(83);
    }

    public void SetTubeDisplayDensity(int tubeDisplayDensity_)
    {
        tubeDisplayDensity = tubeDisplayDensity_;
        Select(84);
    }

    public void SetGeomDisplayQuality(int geomDisplayQuality_)
    {
        geomDisplayQuality = geomDisplayQuality_;
        Select(85);
    }

    public void SetSampleDistance0(double sampleDistance0_)
    {
        sampleDistance0 = sampleDistance0_;
        Select(86);
    }

    public void SetSampleDistance1(double sampleDistance1_)
    {
        sampleDistance1 = sampleDistance1_;
        Select(87);
    }

    public void SetSampleDistance2(double sampleDistance2_)
    {
        sampleDistance2 = sampleDistance2_;
        Select(88);
    }

    public void SetFillInterior(boolean fillInterior_)
    {
        fillInterior = fillInterior_;
        Select(89);
    }

    public void SetRandomSamples(boolean randomSamples_)
    {
        randomSamples = randomSamples_;
        Select(90);
    }

    public void SetRandomSeed(int randomSeed_)
    {
        randomSeed = randomSeed_;
        Select(91);
    }

    public void SetNumberOfRandomSamples(int numberOfRandomSamples_)
    {
        numberOfRandomSamples = numberOfRandomSamples_;
        Select(92);
    }

    public void SetForceNodeCenteredData(boolean forceNodeCenteredData_)
    {
        forceNodeCenteredData = forceNodeCenteredData_;
        Select(93);
    }

    public void SetIssueTerminationWarnings(boolean issueTerminationWarnings_)
    {
        issueTerminationWarnings = issueTerminationWarnings_;
        Select(94);
    }

    public void SetIssueStiffnessWarnings(boolean issueStiffnessWarnings_)
    {
        issueStiffnessWarnings = issueStiffnessWarnings_;
        Select(95);
    }

    public void SetIssueCriticalPointsWarnings(boolean issueCriticalPointsWarnings_)
    {
        issueCriticalPointsWarnings = issueCriticalPointsWarnings_;
        Select(96);
    }

    public void SetCriticalPointThreshold(double criticalPointThreshold_)
    {
        criticalPointThreshold = criticalPointThreshold_;
        Select(97);
    }

    public void SetVaryTubeRadius(int varyTubeRadius_)
    {
        varyTubeRadius = varyTubeRadius_;
        Select(98);
    }

    public void SetVaryTubeRadiusFactor(double varyTubeRadiusFactor_)
    {
        varyTubeRadiusFactor = varyTubeRadiusFactor_;
        Select(99);
    }

    public void SetVaryTubeRadiusVariable(String varyTubeRadiusVariable_)
    {
        varyTubeRadiusVariable = varyTubeRadiusVariable_;
        Select(100);
    }

    public void SetCorrelationDistanceAngTol(double correlationDistanceAngTol_)
    {
        correlationDistanceAngTol = correlationDistanceAngTol_;
        Select(101);
    }

    public void SetCorrelationDistanceMinDistAbsolute(double correlationDistanceMinDistAbsolute_)
    {
        correlationDistanceMinDistAbsolute = correlationDistanceMinDistAbsolute_;
        Select(102);
    }

    public void SetCorrelationDistanceMinDistBBox(double correlationDistanceMinDistBBox_)
    {
        correlationDistanceMinDistBBox = correlationDistanceMinDistBBox_;
        Select(103);
    }

    public void SetCorrelationDistanceMinDistType(int correlationDistanceMinDistType_)
    {
        correlationDistanceMinDistType = correlationDistanceMinDistType_;
        Select(104);
    }

    public void SetSelection(String selection_)
    {
        selection = selection_;
        Select(105);
    }

    // Property getting methods
    public int            GetSourceType() { return sourceType; }
    public double[]       GetPointSource() { return pointSource; }
    public double[]       GetLineStart() { return lineStart; }
    public double[]       GetLineEnd() { return lineEnd; }
    public double[]       GetPlaneOrigin() { return planeOrigin; }
    public double[]       GetPlaneNormal() { return planeNormal; }
    public double[]       GetPlaneUpAxis() { return planeUpAxis; }
    public double         GetRadius() { return radius; }
    public double[]       GetSphereOrigin() { return sphereOrigin; }
    public double[]       GetBoxExtents() { return boxExtents; }
    public boolean        GetUseWholeBox() { return useWholeBox; }
    public Vector         GetPointList() { return pointList; }
    public int            GetSampleDensity0() { return sampleDensity0; }
    public int            GetSampleDensity1() { return sampleDensity1; }
    public int            GetSampleDensity2() { return sampleDensity2; }
    public int            GetColoringMethod() { return coloringMethod; }
    public String         GetColorTableName() { return colorTableName; }
    public ColorAttribute GetSingleColor() { return singleColor; }
    public boolean        GetLegendFlag() { return legendFlag; }
    public boolean        GetLightingFlag() { return lightingFlag; }
    public int            GetIntegrationDirection() { return integrationDirection; }
    public int            GetMaxSteps() { return maxSteps; }
    public boolean        GetTerminateByDistance() { return terminateByDistance; }
    public double         GetTermDistance() { return termDistance; }
    public boolean        GetTerminateByTime() { return terminateByTime; }
    public double         GetTermTime() { return termTime; }
    public double         GetMaxStepLength() { return maxStepLength; }
    public boolean        GetLimitMaximumTimestep() { return limitMaximumTimestep; }
    public double         GetMaxTimeStep() { return maxTimeStep; }
    public double         GetRelTol() { return relTol; }
    public int            GetAbsTolSizeType() { return absTolSizeType; }
    public double         GetAbsTolAbsolute() { return absTolAbsolute; }
    public double         GetAbsTolBBox() { return absTolBBox; }
    public int            GetFieldType() { return fieldType; }
    public double         GetFieldConstant() { return fieldConstant; }
    public double[]       GetVelocitySource() { return velocitySource; }
    public int            GetIntegrationType() { return integrationType; }
    public int            GetParallelizationAlgorithmType() { return parallelizationAlgorithmType; }
    public int            GetMaxProcessCount() { return maxProcessCount; }
    public int            GetMaxDomainCacheSize() { return maxDomainCacheSize; }
    public int            GetWorkGroupSize() { return workGroupSize; }
    public boolean        GetPathlines() { return pathlines; }
    public boolean        GetPathlinesOverrideStartingTimeFlag() { return pathlinesOverrideStartingTimeFlag; }
    public double         GetPathlinesOverrideStartingTime() { return pathlinesOverrideStartingTime; }
    public double         GetPathlinesPeriod() { return pathlinesPeriod; }
    public int            GetPathlinesCMFE() { return pathlinesCMFE; }
    public int            GetCoordinateSystem() { return coordinateSystem; }
    public boolean        GetPhiScalingFlag() { return phiScalingFlag; }
    public double         GetPhiScaling() { return phiScaling; }
    public String         GetColoringVariable() { return coloringVariable; }
    public boolean        GetLegendMinFlag() { return legendMinFlag; }
    public boolean        GetLegendMaxFlag() { return legendMaxFlag; }
    public double         GetLegendMin() { return legendMin; }
    public double         GetLegendMax() { return legendMax; }
    public double         GetDisplayBegin() { return displayBegin; }
    public double         GetDisplayEnd() { return displayEnd; }
    public boolean        GetDisplayBeginFlag() { return displayBeginFlag; }
    public boolean        GetDisplayEndFlag() { return displayEndFlag; }
    public int            GetReferenceTypeForDisplay() { return referenceTypeForDisplay; }
    public int            GetDisplayMethod() { return displayMethod; }
    public int            GetTubeSizeType() { return tubeSizeType; }
    public double         GetTubeRadiusAbsolute() { return tubeRadiusAbsolute; }
    public double         GetTubeRadiusBBox() { return tubeRadiusBBox; }
    public int            GetRibbonWidthSizeType() { return ribbonWidthSizeType; }
    public double         GetRibbonWidthAbsolute() { return ribbonWidthAbsolute; }
    public double         GetRibbonWidthBBox() { return ribbonWidthBBox; }
    public int            GetLineWidth() { return lineWidth; }
    public boolean        GetShowSeeds() { return showSeeds; }
    public int            GetSeedRadiusSizeType() { return seedRadiusSizeType; }
    public double         GetSeedRadiusAbsolute() { return seedRadiusAbsolute; }
    public double         GetSeedRadiusBBox() { return seedRadiusBBox; }
    public boolean        GetShowHeads() { return showHeads; }
    public int            GetHeadDisplayType() { return headDisplayType; }
    public int            GetHeadRadiusSizeType() { return headRadiusSizeType; }
    public double         GetHeadRadiusAbsolute() { return headRadiusAbsolute; }
    public double         GetHeadRadiusBBox() { return headRadiusBBox; }
    public double         GetHeadHeightRatio() { return headHeightRatio; }
    public int            GetOpacityType() { return opacityType; }
    public String         GetOpacityVariable() { return opacityVariable; }
    public double         GetOpacity() { return opacity; }
    public double         GetOpacityVarMin() { return opacityVarMin; }
    public double         GetOpacityVarMax() { return opacityVarMax; }
    public boolean        GetOpacityVarMinFlag() { return opacityVarMinFlag; }
    public boolean        GetOpacityVarMaxFlag() { return opacityVarMaxFlag; }
    public int            GetTubeDisplayDensity() { return tubeDisplayDensity; }
    public int            GetGeomDisplayQuality() { return geomDisplayQuality; }
    public double         GetSampleDistance0() { return sampleDistance0; }
    public double         GetSampleDistance1() { return sampleDistance1; }
    public double         GetSampleDistance2() { return sampleDistance2; }
    public boolean        GetFillInterior() { return fillInterior; }
    public boolean        GetRandomSamples() { return randomSamples; }
    public int            GetRandomSeed() { return randomSeed; }
    public int            GetNumberOfRandomSamples() { return numberOfRandomSamples; }
    public boolean        GetForceNodeCenteredData() { return forceNodeCenteredData; }
    public boolean        GetIssueTerminationWarnings() { return issueTerminationWarnings; }
    public boolean        GetIssueStiffnessWarnings() { return issueStiffnessWarnings; }
    public boolean        GetIssueCriticalPointsWarnings() { return issueCriticalPointsWarnings; }
    public double         GetCriticalPointThreshold() { return criticalPointThreshold; }
    public int            GetVaryTubeRadius() { return varyTubeRadius; }
    public double         GetVaryTubeRadiusFactor() { return varyTubeRadiusFactor; }
    public String         GetVaryTubeRadiusVariable() { return varyTubeRadiusVariable; }
    public double         GetCorrelationDistanceAngTol() { return correlationDistanceAngTol; }
    public double         GetCorrelationDistanceMinDistAbsolute() { return correlationDistanceMinDistAbsolute; }
    public double         GetCorrelationDistanceMinDistBBox() { return correlationDistanceMinDistBBox; }
    public int            GetCorrelationDistanceMinDistType() { return correlationDistanceMinDistType; }
    public String         GetSelection() { return selection; }

    // Write and read methods.
    public void WriteAtts(CommunicationBuffer buf)
    {
        if(WriteSelect(0, buf))
            buf.WriteInt(sourceType);
        if(WriteSelect(1, buf))
            buf.WriteDoubleArray(pointSource);
        if(WriteSelect(2, buf))
            buf.WriteDoubleArray(lineStart);
        if(WriteSelect(3, buf))
            buf.WriteDoubleArray(lineEnd);
        if(WriteSelect(4, buf))
            buf.WriteDoubleArray(planeOrigin);
        if(WriteSelect(5, buf))
            buf.WriteDoubleArray(planeNormal);
        if(WriteSelect(6, buf))
            buf.WriteDoubleArray(planeUpAxis);
        if(WriteSelect(7, buf))
            buf.WriteDouble(radius);
        if(WriteSelect(8, buf))
            buf.WriteDoubleArray(sphereOrigin);
        if(WriteSelect(9, buf))
            buf.WriteDoubleArray(boxExtents);
        if(WriteSelect(10, buf))
            buf.WriteBool(useWholeBox);
        if(WriteSelect(11, buf))
            buf.WriteDoubleVector(pointList);
        if(WriteSelect(12, buf))
            buf.WriteInt(sampleDensity0);
        if(WriteSelect(13, buf))
            buf.WriteInt(sampleDensity1);
        if(WriteSelect(14, buf))
            buf.WriteInt(sampleDensity2);
        if(WriteSelect(15, buf))
            buf.WriteInt(coloringMethod);
        if(WriteSelect(16, buf))
            buf.WriteString(colorTableName);
        if(WriteSelect(17, buf))
            singleColor.Write(buf);
        if(WriteSelect(18, buf))
            buf.WriteBool(legendFlag);
        if(WriteSelect(19, buf))
            buf.WriteBool(lightingFlag);
        if(WriteSelect(20, buf))
            buf.WriteInt(integrationDirection);
        if(WriteSelect(21, buf))
            buf.WriteInt(maxSteps);
        if(WriteSelect(22, buf))
            buf.WriteBool(terminateByDistance);
        if(WriteSelect(23, buf))
            buf.WriteDouble(termDistance);
        if(WriteSelect(24, buf))
            buf.WriteBool(terminateByTime);
        if(WriteSelect(25, buf))
            buf.WriteDouble(termTime);
        if(WriteSelect(26, buf))
            buf.WriteDouble(maxStepLength);
        if(WriteSelect(27, buf))
            buf.WriteBool(limitMaximumTimestep);
        if(WriteSelect(28, buf))
            buf.WriteDouble(maxTimeStep);
        if(WriteSelect(29, buf))
            buf.WriteDouble(relTol);
        if(WriteSelect(30, buf))
            buf.WriteInt(absTolSizeType);
        if(WriteSelect(31, buf))
            buf.WriteDouble(absTolAbsolute);
        if(WriteSelect(32, buf))
            buf.WriteDouble(absTolBBox);
        if(WriteSelect(33, buf))
            buf.WriteInt(fieldType);
        if(WriteSelect(34, buf))
            buf.WriteDouble(fieldConstant);
        if(WriteSelect(35, buf))
            buf.WriteDoubleArray(velocitySource);
        if(WriteSelect(36, buf))
            buf.WriteInt(integrationType);
        if(WriteSelect(37, buf))
            buf.WriteInt(parallelizationAlgorithmType);
        if(WriteSelect(38, buf))
            buf.WriteInt(maxProcessCount);
        if(WriteSelect(39, buf))
            buf.WriteInt(maxDomainCacheSize);
        if(WriteSelect(40, buf))
            buf.WriteInt(workGroupSize);
        if(WriteSelect(41, buf))
            buf.WriteBool(pathlines);
        if(WriteSelect(42, buf))
            buf.WriteBool(pathlinesOverrideStartingTimeFlag);
        if(WriteSelect(43, buf))
            buf.WriteDouble(pathlinesOverrideStartingTime);
        if(WriteSelect(44, buf))
            buf.WriteDouble(pathlinesPeriod);
        if(WriteSelect(45, buf))
            buf.WriteInt(pathlinesCMFE);
        if(WriteSelect(46, buf))
            buf.WriteInt(coordinateSystem);
        if(WriteSelect(47, buf))
            buf.WriteBool(phiScalingFlag);
        if(WriteSelect(48, buf))
            buf.WriteDouble(phiScaling);
        if(WriteSelect(49, buf))
            buf.WriteString(coloringVariable);
        if(WriteSelect(50, buf))
            buf.WriteBool(legendMinFlag);
        if(WriteSelect(51, buf))
            buf.WriteBool(legendMaxFlag);
        if(WriteSelect(52, buf))
            buf.WriteDouble(legendMin);
        if(WriteSelect(53, buf))
            buf.WriteDouble(legendMax);
        if(WriteSelect(54, buf))
            buf.WriteDouble(displayBegin);
        if(WriteSelect(55, buf))
            buf.WriteDouble(displayEnd);
        if(WriteSelect(56, buf))
            buf.WriteBool(displayBeginFlag);
        if(WriteSelect(57, buf))
            buf.WriteBool(displayEndFlag);
        if(WriteSelect(58, buf))
            buf.WriteInt(referenceTypeForDisplay);
        if(WriteSelect(59, buf))
            buf.WriteInt(displayMethod);
        if(WriteSelect(60, buf))
            buf.WriteInt(tubeSizeType);
        if(WriteSelect(61, buf))
            buf.WriteDouble(tubeRadiusAbsolute);
        if(WriteSelect(62, buf))
            buf.WriteDouble(tubeRadiusBBox);
        if(WriteSelect(63, buf))
            buf.WriteInt(ribbonWidthSizeType);
        if(WriteSelect(64, buf))
            buf.WriteDouble(ribbonWidthAbsolute);
        if(WriteSelect(65, buf))
            buf.WriteDouble(ribbonWidthBBox);
        if(WriteSelect(66, buf))
            buf.WriteInt(lineWidth);
        if(WriteSelect(67, buf))
            buf.WriteBool(showSeeds);
        if(WriteSelect(68, buf))
            buf.WriteInt(seedRadiusSizeType);
        if(WriteSelect(69, buf))
            buf.WriteDouble(seedRadiusAbsolute);
        if(WriteSelect(70, buf))
            buf.WriteDouble(seedRadiusBBox);
        if(WriteSelect(71, buf))
            buf.WriteBool(showHeads);
        if(WriteSelect(72, buf))
            buf.WriteInt(headDisplayType);
        if(WriteSelect(73, buf))
            buf.WriteInt(headRadiusSizeType);
        if(WriteSelect(74, buf))
            buf.WriteDouble(headRadiusAbsolute);
        if(WriteSelect(75, buf))
            buf.WriteDouble(headRadiusBBox);
        if(WriteSelect(76, buf))
            buf.WriteDouble(headHeightRatio);
        if(WriteSelect(77, buf))
            buf.WriteInt(opacityType);
        if(WriteSelect(78, buf))
            buf.WriteString(opacityVariable);
        if(WriteSelect(79, buf))
            buf.WriteDouble(opacity);
        if(WriteSelect(80, buf))
            buf.WriteDouble(opacityVarMin);
        if(WriteSelect(81, buf))
            buf.WriteDouble(opacityVarMax);
        if(WriteSelect(82, buf))
            buf.WriteBool(opacityVarMinFlag);
        if(WriteSelect(83, buf))
            buf.WriteBool(opacityVarMaxFlag);
        if(WriteSelect(84, buf))
            buf.WriteInt(tubeDisplayDensity);
        if(WriteSelect(85, buf))
            buf.WriteInt(geomDisplayQuality);
        if(WriteSelect(86, buf))
            buf.WriteDouble(sampleDistance0);
        if(WriteSelect(87, buf))
            buf.WriteDouble(sampleDistance1);
        if(WriteSelect(88, buf))
            buf.WriteDouble(sampleDistance2);
        if(WriteSelect(89, buf))
            buf.WriteBool(fillInterior);
        if(WriteSelect(90, buf))
            buf.WriteBool(randomSamples);
        if(WriteSelect(91, buf))
            buf.WriteInt(randomSeed);
        if(WriteSelect(92, buf))
            buf.WriteInt(numberOfRandomSamples);
        if(WriteSelect(93, buf))
            buf.WriteBool(forceNodeCenteredData);
        if(WriteSelect(94, buf))
            buf.WriteBool(issueTerminationWarnings);
        if(WriteSelect(95, buf))
            buf.WriteBool(issueStiffnessWarnings);
        if(WriteSelect(96, buf))
            buf.WriteBool(issueCriticalPointsWarnings);
        if(WriteSelect(97, buf))
            buf.WriteDouble(criticalPointThreshold);
        if(WriteSelect(98, buf))
            buf.WriteInt(varyTubeRadius);
        if(WriteSelect(99, buf))
            buf.WriteDouble(varyTubeRadiusFactor);
        if(WriteSelect(100, buf))
            buf.WriteString(varyTubeRadiusVariable);
        if(WriteSelect(101, buf))
            buf.WriteDouble(correlationDistanceAngTol);
        if(WriteSelect(102, buf))
            buf.WriteDouble(correlationDistanceMinDistAbsolute);
        if(WriteSelect(103, buf))
            buf.WriteDouble(correlationDistanceMinDistBBox);
        if(WriteSelect(104, buf))
            buf.WriteInt(correlationDistanceMinDistType);
        if(WriteSelect(105, buf))
            buf.WriteString(selection);
    }

    public void ReadAtts(int index, CommunicationBuffer buf)
    {
        switch(index)
        {
        case 0:
            SetSourceType(buf.ReadInt());
            break;
        case 1:
            SetPointSource(buf.ReadDoubleArray());
            break;
        case 2:
            SetLineStart(buf.ReadDoubleArray());
            break;
        case 3:
            SetLineEnd(buf.ReadDoubleArray());
            break;
        case 4:
            SetPlaneOrigin(buf.ReadDoubleArray());
            break;
        case 5:
            SetPlaneNormal(buf.ReadDoubleArray());
            break;
        case 6:
            SetPlaneUpAxis(buf.ReadDoubleArray());
            break;
        case 7:
            SetRadius(buf.ReadDouble());
            break;
        case 8:
            SetSphereOrigin(buf.ReadDoubleArray());
            break;
        case 9:
            SetBoxExtents(buf.ReadDoubleArray());
            break;
        case 10:
            SetUseWholeBox(buf.ReadBool());
            break;
        case 11:
            SetPointList(buf.ReadDoubleVector());
            break;
        case 12:
            SetSampleDensity0(buf.ReadInt());
            break;
        case 13:
            SetSampleDensity1(buf.ReadInt());
            break;
        case 14:
            SetSampleDensity2(buf.ReadInt());
            break;
        case 15:
            SetColoringMethod(buf.ReadInt());
            break;
        case 16:
            SetColorTableName(buf.ReadString());
            break;
        case 17:
            singleColor.Read(buf);
            Select(17);
            break;
        case 18:
            SetLegendFlag(buf.ReadBool());
            break;
        case 19:
            SetLightingFlag(buf.ReadBool());
            break;
        case 20:
            SetIntegrationDirection(buf.ReadInt());
            break;
        case 21:
            SetMaxSteps(buf.ReadInt());
            break;
        case 22:
            SetTerminateByDistance(buf.ReadBool());
            break;
        case 23:
            SetTermDistance(buf.ReadDouble());
            break;
        case 24:
            SetTerminateByTime(buf.ReadBool());
            break;
        case 25:
            SetTermTime(buf.ReadDouble());
            break;
        case 26:
            SetMaxStepLength(buf.ReadDouble());
            break;
        case 27:
            SetLimitMaximumTimestep(buf.ReadBool());
            break;
        case 28:
            SetMaxTimeStep(buf.ReadDouble());
            break;
        case 29:
            SetRelTol(buf.ReadDouble());
            break;
        case 30:
            SetAbsTolSizeType(buf.ReadInt());
            break;
        case 31:
            SetAbsTolAbsolute(buf.ReadDouble());
            break;
        case 32:
            SetAbsTolBBox(buf.ReadDouble());
            break;
        case 33:
            SetFieldType(buf.ReadInt());
            break;
        case 34:
            SetFieldConstant(buf.ReadDouble());
            break;
        case 35:
            SetVelocitySource(buf.ReadDoubleArray());
            break;
        case 36:
            SetIntegrationType(buf.ReadInt());
            break;
        case 37:
            SetParallelizationAlgorithmType(buf.ReadInt());
            break;
        case 38:
            SetMaxProcessCount(buf.ReadInt());
            break;
        case 39:
            SetMaxDomainCacheSize(buf.ReadInt());
            break;
        case 40:
            SetWorkGroupSize(buf.ReadInt());
            break;
        case 41:
            SetPathlines(buf.ReadBool());
            break;
        case 42:
            SetPathlinesOverrideStartingTimeFlag(buf.ReadBool());
            break;
        case 43:
            SetPathlinesOverrideStartingTime(buf.ReadDouble());
            break;
        case 44:
            SetPathlinesPeriod(buf.ReadDouble());
            break;
        case 45:
            SetPathlinesCMFE(buf.ReadInt());
            break;
        case 46:
            SetCoordinateSystem(buf.ReadInt());
            break;
        case 47:
            SetPhiScalingFlag(buf.ReadBool());
            break;
        case 48:
            SetPhiScaling(buf.ReadDouble());
            break;
        case 49:
            SetColoringVariable(buf.ReadString());
            break;
        case 50:
            SetLegendMinFlag(buf.ReadBool());
            break;
        case 51:
            SetLegendMaxFlag(buf.ReadBool());
            break;
        case 52:
            SetLegendMin(buf.ReadDouble());
            break;
        case 53:
            SetLegendMax(buf.ReadDouble());
            break;
        case 54:
            SetDisplayBegin(buf.ReadDouble());
            break;
        case 55:
            SetDisplayEnd(buf.ReadDouble());
            break;
        case 56:
            SetDisplayBeginFlag(buf.ReadBool());
            break;
        case 57:
            SetDisplayEndFlag(buf.ReadBool());
            break;
        case 58:
            SetReferenceTypeForDisplay(buf.ReadInt());
            break;
        case 59:
            SetDisplayMethod(buf.ReadInt());
            break;
        case 60:
            SetTubeSizeType(buf.ReadInt());
            break;
        case 61:
            SetTubeRadiusAbsolute(buf.ReadDouble());
            break;
        case 62:
            SetTubeRadiusBBox(buf.ReadDouble());
            break;
        case 63:
            SetRibbonWidthSizeType(buf.ReadInt());
            break;
        case 64:
            SetRibbonWidthAbsolute(buf.ReadDouble());
            break;
        case 65:
            SetRibbonWidthBBox(buf.ReadDouble());
            break;
        case 66:
            SetLineWidth(buf.ReadInt());
            break;
        case 67:
            SetShowSeeds(buf.ReadBool());
            break;
        case 68:
            SetSeedRadiusSizeType(buf.ReadInt());
            break;
        case 69:
            SetSeedRadiusAbsolute(buf.ReadDouble());
            break;
        case 70:
            SetSeedRadiusBBox(buf.ReadDouble());
            break;
        case 71:
            SetShowHeads(buf.ReadBool());
            break;
        case 72:
            SetHeadDisplayType(buf.ReadInt());
            break;
        case 73:
            SetHeadRadiusSizeType(buf.ReadInt());
            break;
        case 74:
            SetHeadRadiusAbsolute(buf.ReadDouble());
            break;
        case 75:
            SetHeadRadiusBBox(buf.ReadDouble());
            break;
        case 76:
            SetHeadHeightRatio(buf.ReadDouble());
            break;
        case 77:
            SetOpacityType(buf.ReadInt());
            break;
        case 78:
            SetOpacityVariable(buf.ReadString());
            break;
        case 79:
            SetOpacity(buf.ReadDouble());
            break;
        case 80:
            SetOpacityVarMin(buf.ReadDouble());
            break;
        case 81:
            SetOpacityVarMax(buf.ReadDouble());
            break;
        case 82:
            SetOpacityVarMinFlag(buf.ReadBool());
            break;
        case 83:
            SetOpacityVarMaxFlag(buf.ReadBool());
            break;
        case 84:
            SetTubeDisplayDensity(buf.ReadInt());
            break;
        case 85:
            SetGeomDisplayQuality(buf.ReadInt());
            break;
        case 86:
            SetSampleDistance0(buf.ReadDouble());
            break;
        case 87:
            SetSampleDistance1(buf.ReadDouble());
            break;
        case 88:
            SetSampleDistance2(buf.ReadDouble());
            break;
        case 89:
            SetFillInterior(buf.ReadBool());
            break;
        case 90:
            SetRandomSamples(buf.ReadBool());
            break;
        case 91:
            SetRandomSeed(buf.ReadInt());
            break;
        case 92:
            SetNumberOfRandomSamples(buf.ReadInt());
            break;
        case 93:
            SetForceNodeCenteredData(buf.ReadBool());
            break;
        case 94:
            SetIssueTerminationWarnings(buf.ReadBool());
            break;
        case 95:
            SetIssueStiffnessWarnings(buf.ReadBool());
            break;
        case 96:
            SetIssueCriticalPointsWarnings(buf.ReadBool());
            break;
        case 97:
            SetCriticalPointThreshold(buf.ReadDouble());
            break;
        case 98:
            SetVaryTubeRadius(buf.ReadInt());
            break;
        case 99:
            SetVaryTubeRadiusFactor(buf.ReadDouble());
            break;
        case 100:
            SetVaryTubeRadiusVariable(buf.ReadString());
            break;
        case 101:
            SetCorrelationDistanceAngTol(buf.ReadDouble());
            break;
        case 102:
            SetCorrelationDistanceMinDistAbsolute(buf.ReadDouble());
            break;
        case 103:
            SetCorrelationDistanceMinDistBBox(buf.ReadDouble());
            break;
        case 104:
            SetCorrelationDistanceMinDistType(buf.ReadInt());
            break;
        case 105:
            SetSelection(buf.ReadString());
            break;
        }
    }

    public String toString(String indent)
    {
        String str = new String();
        str = str + indent + "sourceType = ";
        if(sourceType == SOURCETYPE_SPECIFIEDPOINT)
            str = str + "SOURCETYPE_SPECIFIEDPOINT";
        if(sourceType == SOURCETYPE_SPECIFIEDPOINTLIST)
            str = str + "SOURCETYPE_SPECIFIEDPOINTLIST";
        if(sourceType == SOURCETYPE_SPECIFIEDLINE)
            str = str + "SOURCETYPE_SPECIFIEDLINE";
        if(sourceType == SOURCETYPE_SPECIFIEDCIRCLE)
            str = str + "SOURCETYPE_SPECIFIEDCIRCLE";
        if(sourceType == SOURCETYPE_SPECIFIEDPLANE)
            str = str + "SOURCETYPE_SPECIFIEDPLANE";
        if(sourceType == SOURCETYPE_SPECIFIEDSPHERE)
            str = str + "SOURCETYPE_SPECIFIEDSPHERE";
        if(sourceType == SOURCETYPE_SPECIFIEDBOX)
            str = str + "SOURCETYPE_SPECIFIEDBOX";
        if(sourceType == SOURCETYPE_SELECTION)
            str = str + "SOURCETYPE_SELECTION";
        str = str + "\n";
        str = str + doubleArrayToString("pointSource", pointSource, indent) + "\n";
        str = str + doubleArrayToString("lineStart", lineStart, indent) + "\n";
        str = str + doubleArrayToString("lineEnd", lineEnd, indent) + "\n";
        str = str + doubleArrayToString("planeOrigin", planeOrigin, indent) + "\n";
        str = str + doubleArrayToString("planeNormal", planeNormal, indent) + "\n";
        str = str + doubleArrayToString("planeUpAxis", planeUpAxis, indent) + "\n";
        str = str + doubleToString("radius", radius, indent) + "\n";
        str = str + doubleArrayToString("sphereOrigin", sphereOrigin, indent) + "\n";
        str = str + doubleArrayToString("boxExtents", boxExtents, indent) + "\n";
        str = str + boolToString("useWholeBox", useWholeBox, indent) + "\n";
        str = str + doubleVectorToString("pointList", pointList, indent) + "\n";
        str = str + intToString("sampleDensity0", sampleDensity0, indent) + "\n";
        str = str + intToString("sampleDensity1", sampleDensity1, indent) + "\n";
        str = str + intToString("sampleDensity2", sampleDensity2, indent) + "\n";
        str = str + indent + "coloringMethod = ";
        if(coloringMethod == COLORINGMETHOD_SOLID)
            str = str + "COLORINGMETHOD_SOLID";
        if(coloringMethod == COLORINGMETHOD_COLORBYSPEED)
            str = str + "COLORINGMETHOD_COLORBYSPEED";
        if(coloringMethod == COLORINGMETHOD_COLORBYVORTICITY)
            str = str + "COLORINGMETHOD_COLORBYVORTICITY";
        if(coloringMethod == COLORINGMETHOD_COLORBYLENGTH)
            str = str + "COLORINGMETHOD_COLORBYLENGTH";
        if(coloringMethod == COLORINGMETHOD_COLORBYTIME)
            str = str + "COLORINGMETHOD_COLORBYTIME";
        if(coloringMethod == COLORINGMETHOD_COLORBYSEEDPOINTID)
            str = str + "COLORINGMETHOD_COLORBYSEEDPOINTID";
        if(coloringMethod == COLORINGMETHOD_COLORBYVARIABLE)
            str = str + "COLORINGMETHOD_COLORBYVARIABLE";
        if(coloringMethod == COLORINGMETHOD_COLORBYCORRELATIONDISTANCE)
            str = str + "COLORINGMETHOD_COLORBYCORRELATIONDISTANCE";
        str = str + "\n";
        str = str + stringToString("colorTableName", colorTableName, indent) + "\n";
        str = str + indent + "singleColor = {" + singleColor.Red() + ", " + singleColor.Green() + ", " + singleColor.Blue() + ", " + singleColor.Alpha() + "}\n";
        str = str + boolToString("legendFlag", legendFlag, indent) + "\n";
        str = str + boolToString("lightingFlag", lightingFlag, indent) + "\n";
        str = str + indent + "integrationDirection = ";
        if(integrationDirection == INTEGRATIONDIRECTION_FORWARD)
            str = str + "INTEGRATIONDIRECTION_FORWARD";
        if(integrationDirection == INTEGRATIONDIRECTION_BACKWARD)
            str = str + "INTEGRATIONDIRECTION_BACKWARD";
        if(integrationDirection == INTEGRATIONDIRECTION_BOTH)
            str = str + "INTEGRATIONDIRECTION_BOTH";
        str = str + "\n";
        str = str + intToString("maxSteps", maxSteps, indent) + "\n";
        str = str + boolToString("terminateByDistance", terminateByDistance, indent) + "\n";
        str = str + doubleToString("termDistance", termDistance, indent) + "\n";
        str = str + boolToString("terminateByTime", terminateByTime, indent) + "\n";
        str = str + doubleToString("termTime", termTime, indent) + "\n";
        str = str + doubleToString("maxStepLength", maxStepLength, indent) + "\n";
        str = str + boolToString("limitMaximumTimestep", limitMaximumTimestep, indent) + "\n";
        str = str + doubleToString("maxTimeStep", maxTimeStep, indent) + "\n";
        str = str + doubleToString("relTol", relTol, indent) + "\n";
        str = str + indent + "absTolSizeType = ";
        if(absTolSizeType == SIZETYPE_ABSOLUTE)
            str = str + "SIZETYPE_ABSOLUTE";
        if(absTolSizeType == SIZETYPE_FRACTIONOFBBOX)
            str = str + "SIZETYPE_FRACTIONOFBBOX";
        str = str + "\n";
        str = str + doubleToString("absTolAbsolute", absTolAbsolute, indent) + "\n";
        str = str + doubleToString("absTolBBox", absTolBBox, indent) + "\n";
        str = str + indent + "fieldType = ";
        if(fieldType == FIELDTYPE_DEFAULT)
            str = str + "FIELDTYPE_DEFAULT";
        if(fieldType == FIELDTYPE_FLASHFIELD)
            str = str + "FIELDTYPE_FLASHFIELD";
        if(fieldType == FIELDTYPE_M3DC12DFIELD)
            str = str + "FIELDTYPE_M3DC12DFIELD";
        if(fieldType == FIELDTYPE_M3DC13DFIELD)
            str = str + "FIELDTYPE_M3DC13DFIELD";
        if(fieldType == FIELDTYPE_NEK5000FIELD)
            str = str + "FIELDTYPE_NEK5000FIELD";
        if(fieldType == FIELDTYPE_NIMRODFIELD)
            str = str + "FIELDTYPE_NIMRODFIELD";
        str = str + "\n";
        str = str + doubleToString("fieldConstant", fieldConstant, indent) + "\n";
        str = str + doubleArrayToString("velocitySource", velocitySource, indent) + "\n";
        str = str + indent + "integrationType = ";
        if(integrationType == INTEGRATIONTYPE_EULER)
            str = str + "INTEGRATIONTYPE_EULER";
        if(integrationType == INTEGRATIONTYPE_LEAPFROG)
            str = str + "INTEGRATIONTYPE_LEAPFROG";
        if(integrationType == INTEGRATIONTYPE_DORMANDPRINCE)
            str = str + "INTEGRATIONTYPE_DORMANDPRINCE";
        if(integrationType == INTEGRATIONTYPE_ADAMSBASHFORTH)
            str = str + "INTEGRATIONTYPE_ADAMSBASHFORTH";
        if(integrationType == INTEGRATIONTYPE_RK4)
            str = str + "INTEGRATIONTYPE_RK4";
        if(integrationType == INTEGRATIONTYPE_M3DC12DINTEGRATOR)
            str = str + "INTEGRATIONTYPE_M3DC12DINTEGRATOR";
        str = str + "\n";
        str = str + indent + "parallelizationAlgorithmType = ";
        if(parallelizationAlgorithmType == PARALLELIZATIONALGORITHMTYPE_LOADONDEMAND)
            str = str + "PARALLELIZATIONALGORITHMTYPE_LOADONDEMAND";
        if(parallelizationAlgorithmType == PARALLELIZATIONALGORITHMTYPE_PARALLELSTATICDOMAINS)
            str = str + "PARALLELIZATIONALGORITHMTYPE_PARALLELSTATICDOMAINS";
        if(parallelizationAlgorithmType == PARALLELIZATIONALGORITHMTYPE_MASTERSLAVE)
            str = str + "PARALLELIZATIONALGORITHMTYPE_MASTERSLAVE";
        if(parallelizationAlgorithmType == PARALLELIZATIONALGORITHMTYPE_VISITSELECTS)
            str = str + "PARALLELIZATIONALGORITHMTYPE_VISITSELECTS";
        str = str + "\n";
        str = str + intToString("maxProcessCount", maxProcessCount, indent) + "\n";
        str = str + intToString("maxDomainCacheSize", maxDomainCacheSize, indent) + "\n";
        str = str + intToString("workGroupSize", workGroupSize, indent) + "\n";
        str = str + boolToString("pathlines", pathlines, indent) + "\n";
        str = str + boolToString("pathlinesOverrideStartingTimeFlag", pathlinesOverrideStartingTimeFlag, indent) + "\n";
        str = str + doubleToString("pathlinesOverrideStartingTime", pathlinesOverrideStartingTime, indent) + "\n";
        str = str + doubleToString("pathlinesPeriod", pathlinesPeriod, indent) + "\n";
        str = str + indent + "pathlinesCMFE = ";
        if(pathlinesCMFE == PATHLINESCMFE_CONN_CMFE)
            str = str + "PATHLINESCMFE_CONN_CMFE";
        if(pathlinesCMFE == PATHLINESCMFE_POS_CMFE)
            str = str + "PATHLINESCMFE_POS_CMFE";
        str = str + "\n";
        str = str + indent + "coordinateSystem = ";
        if(coordinateSystem == COORDINATESYSTEM_ASIS)
            str = str + "COORDINATESYSTEM_ASIS";
        if(coordinateSystem == COORDINATESYSTEM_CYLINDRICALTOCARTESIAN)
            str = str + "COORDINATESYSTEM_CYLINDRICALTOCARTESIAN";
        if(coordinateSystem == COORDINATESYSTEM_CARTESIANTOCYLINDRICAL)
            str = str + "COORDINATESYSTEM_CARTESIANTOCYLINDRICAL";
        str = str + "\n";
        str = str + boolToString("phiScalingFlag", phiScalingFlag, indent) + "\n";
        str = str + doubleToString("phiScaling", phiScaling, indent) + "\n";
        str = str + stringToString("coloringVariable", coloringVariable, indent) + "\n";
        str = str + boolToString("legendMinFlag", legendMinFlag, indent) + "\n";
        str = str + boolToString("legendMaxFlag", legendMaxFlag, indent) + "\n";
        str = str + doubleToString("legendMin", legendMin, indent) + "\n";
        str = str + doubleToString("legendMax", legendMax, indent) + "\n";
        str = str + doubleToString("displayBegin", displayBegin, indent) + "\n";
        str = str + doubleToString("displayEnd", displayEnd, indent) + "\n";
        str = str + boolToString("displayBeginFlag", displayBeginFlag, indent) + "\n";
        str = str + boolToString("displayEndFlag", displayEndFlag, indent) + "\n";
        str = str + indent + "referenceTypeForDisplay = ";
        if(referenceTypeForDisplay == REFERENCETYPE_DISTANCE)
            str = str + "REFERENCETYPE_DISTANCE";
        if(referenceTypeForDisplay == REFERENCETYPE_TIME)
            str = str + "REFERENCETYPE_TIME";
        if(referenceTypeForDisplay == REFERENCETYPE_STEP)
            str = str + "REFERENCETYPE_STEP";
        str = str + "\n";
        str = str + indent + "displayMethod = ";
        if(displayMethod == DISPLAYMETHOD_LINES)
            str = str + "DISPLAYMETHOD_LINES";
        if(displayMethod == DISPLAYMETHOD_TUBES)
            str = str + "DISPLAYMETHOD_TUBES";
        if(displayMethod == DISPLAYMETHOD_RIBBONS)
            str = str + "DISPLAYMETHOD_RIBBONS";
        str = str + "\n";
        str = str + indent + "tubeSizeType = ";
        if(tubeSizeType == SIZETYPE_ABSOLUTE)
            str = str + "SIZETYPE_ABSOLUTE";
        if(tubeSizeType == SIZETYPE_FRACTIONOFBBOX)
            str = str + "SIZETYPE_FRACTIONOFBBOX";
        str = str + "\n";
        str = str + doubleToString("tubeRadiusAbsolute", tubeRadiusAbsolute, indent) + "\n";
        str = str + doubleToString("tubeRadiusBBox", tubeRadiusBBox, indent) + "\n";
        str = str + indent + "ribbonWidthSizeType = ";
        if(ribbonWidthSizeType == SIZETYPE_ABSOLUTE)
            str = str + "SIZETYPE_ABSOLUTE";
        if(ribbonWidthSizeType == SIZETYPE_FRACTIONOFBBOX)
            str = str + "SIZETYPE_FRACTIONOFBBOX";
        str = str + "\n";
        str = str + doubleToString("ribbonWidthAbsolute", ribbonWidthAbsolute, indent) + "\n";
        str = str + doubleToString("ribbonWidthBBox", ribbonWidthBBox, indent) + "\n";
        str = str + intToString("lineWidth", lineWidth, indent) + "\n";
        str = str + boolToString("showSeeds", showSeeds, indent) + "\n";
        str = str + indent + "seedRadiusSizeType = ";
        if(seedRadiusSizeType == SIZETYPE_ABSOLUTE)
            str = str + "SIZETYPE_ABSOLUTE";
        if(seedRadiusSizeType == SIZETYPE_FRACTIONOFBBOX)
            str = str + "SIZETYPE_FRACTIONOFBBOX";
        str = str + "\n";
        str = str + doubleToString("seedRadiusAbsolute", seedRadiusAbsolute, indent) + "\n";
        str = str + doubleToString("seedRadiusBBox", seedRadiusBBox, indent) + "\n";
        str = str + boolToString("showHeads", showHeads, indent) + "\n";
        str = str + indent + "headDisplayType = ";
        if(headDisplayType == GEOMDISPLAYTYPE_SPHERE)
            str = str + "GEOMDISPLAYTYPE_SPHERE";
        if(headDisplayType == GEOMDISPLAYTYPE_CONE)
            str = str + "GEOMDISPLAYTYPE_CONE";
        str = str + "\n";
        str = str + indent + "headRadiusSizeType = ";
        if(headRadiusSizeType == SIZETYPE_ABSOLUTE)
            str = str + "SIZETYPE_ABSOLUTE";
        if(headRadiusSizeType == SIZETYPE_FRACTIONOFBBOX)
            str = str + "SIZETYPE_FRACTIONOFBBOX";
        str = str + "\n";
        str = str + doubleToString("headRadiusAbsolute", headRadiusAbsolute, indent) + "\n";
        str = str + doubleToString("headRadiusBBox", headRadiusBBox, indent) + "\n";
        str = str + doubleToString("headHeightRatio", headHeightRatio, indent) + "\n";
        str = str + indent + "opacityType = ";
        if(opacityType == OPACITYTYPE_FULLYOPAQUE)
            str = str + "OPACITYTYPE_FULLYOPAQUE";
        if(opacityType == OPACITYTYPE_CONSTANT)
            str = str + "OPACITYTYPE_CONSTANT";
        if(opacityType == OPACITYTYPE_RAMP)
            str = str + "OPACITYTYPE_RAMP";
        if(opacityType == OPACITYTYPE_VARIABLERANGE)
            str = str + "OPACITYTYPE_VARIABLERANGE";
        str = str + "\n";
        str = str + stringToString("opacityVariable", opacityVariable, indent) + "\n";
        str = str + doubleToString("opacity", opacity, indent) + "\n";
        str = str + doubleToString("opacityVarMin", opacityVarMin, indent) + "\n";
        str = str + doubleToString("opacityVarMax", opacityVarMax, indent) + "\n";
        str = str + boolToString("opacityVarMinFlag", opacityVarMinFlag, indent) + "\n";
        str = str + boolToString("opacityVarMaxFlag", opacityVarMaxFlag, indent) + "\n";
        str = str + intToString("tubeDisplayDensity", tubeDisplayDensity, indent) + "\n";
        str = str + indent + "geomDisplayQuality = ";
        if(geomDisplayQuality == DISPLAYQUALITY_LOW)
            str = str + "DISPLAYQUALITY_LOW";
        if(geomDisplayQuality == DISPLAYQUALITY_MEDIUM)
            str = str + "DISPLAYQUALITY_MEDIUM";
        if(geomDisplayQuality == DISPLAYQUALITY_HIGH)
            str = str + "DISPLAYQUALITY_HIGH";
        if(geomDisplayQuality == DISPLAYQUALITY_SUPER)
            str = str + "DISPLAYQUALITY_SUPER";
        str = str + "\n";
        str = str + doubleToString("sampleDistance0", sampleDistance0, indent) + "\n";
        str = str + doubleToString("sampleDistance1", sampleDistance1, indent) + "\n";
        str = str + doubleToString("sampleDistance2", sampleDistance2, indent) + "\n";
        str = str + boolToString("fillInterior", fillInterior, indent) + "\n";
        str = str + boolToString("randomSamples", randomSamples, indent) + "\n";
        str = str + intToString("randomSeed", randomSeed, indent) + "\n";
        str = str + intToString("numberOfRandomSamples", numberOfRandomSamples, indent) + "\n";
        str = str + boolToString("forceNodeCenteredData", forceNodeCenteredData, indent) + "\n";
        str = str + boolToString("issueTerminationWarnings", issueTerminationWarnings, indent) + "\n";
        str = str + boolToString("issueStiffnessWarnings", issueStiffnessWarnings, indent) + "\n";
        str = str + boolToString("issueCriticalPointsWarnings", issueCriticalPointsWarnings, indent) + "\n";
        str = str + doubleToString("criticalPointThreshold", criticalPointThreshold, indent) + "\n";
        str = str + indent + "varyTubeRadius = ";
        if(varyTubeRadius == VARYTUBERADIUSTYPE_NONE)
            str = str + "VARYTUBERADIUSTYPE_NONE";
        if(varyTubeRadius == VARYTUBERADIUSTYPE_SCALAR)
            str = str + "VARYTUBERADIUSTYPE_SCALAR";
        str = str + "\n";
        str = str + doubleToString("varyTubeRadiusFactor", varyTubeRadiusFactor, indent) + "\n";
        str = str + stringToString("varyTubeRadiusVariable", varyTubeRadiusVariable, indent) + "\n";
        str = str + doubleToString("correlationDistanceAngTol", correlationDistanceAngTol, indent) + "\n";
        str = str + doubleToString("correlationDistanceMinDistAbsolute", correlationDistanceMinDistAbsolute, indent) + "\n";
        str = str + doubleToString("correlationDistanceMinDistBBox", correlationDistanceMinDistBBox, indent) + "\n";
        str = str + indent + "correlationDistanceMinDistType = ";
        if(correlationDistanceMinDistType == SIZETYPE_ABSOLUTE)
            str = str + "SIZETYPE_ABSOLUTE";
        if(correlationDistanceMinDistType == SIZETYPE_FRACTIONOFBBOX)
            str = str + "SIZETYPE_FRACTIONOFBBOX";
        str = str + "\n";
        str = str + stringToString("selection", selection, indent) + "\n";
        return str;
    }


    // Attributes
    private int            sourceType;
    private double[]       pointSource;
    private double[]       lineStart;
    private double[]       lineEnd;
    private double[]       planeOrigin;
    private double[]       planeNormal;
    private double[]       planeUpAxis;
    private double         radius;
    private double[]       sphereOrigin;
    private double[]       boxExtents;
    private boolean        useWholeBox;
    private Vector         pointList; // vector of Double objects
    private int            sampleDensity0;
    private int            sampleDensity1;
    private int            sampleDensity2;
    private int            coloringMethod;
    private String         colorTableName;
    private ColorAttribute singleColor;
    private boolean        legendFlag;
    private boolean        lightingFlag;
    private int            integrationDirection;
    private int            maxSteps;
    private boolean        terminateByDistance;
    private double         termDistance;
    private boolean        terminateByTime;
    private double         termTime;
    private double         maxStepLength;
    private boolean        limitMaximumTimestep;
    private double         maxTimeStep;
    private double         relTol;
    private int            absTolSizeType;
    private double         absTolAbsolute;
    private double         absTolBBox;
    private int            fieldType;
    private double         fieldConstant;
    private double[]       velocitySource;
    private int            integrationType;
    private int            parallelizationAlgorithmType;
    private int            maxProcessCount;
    private int            maxDomainCacheSize;
    private int            workGroupSize;
    private boolean        pathlines;
    private boolean        pathlinesOverrideStartingTimeFlag;
    private double         pathlinesOverrideStartingTime;
    private double         pathlinesPeriod;
    private int            pathlinesCMFE;
    private int            coordinateSystem;
    private boolean        phiScalingFlag;
    private double         phiScaling;
    private String         coloringVariable;
    private boolean        legendMinFlag;
    private boolean        legendMaxFlag;
    private double         legendMin;
    private double         legendMax;
    private double         displayBegin;
    private double         displayEnd;
    private boolean        displayBeginFlag;
    private boolean        displayEndFlag;
    private int            referenceTypeForDisplay;
    private int            displayMethod;
    private int            tubeSizeType;
    private double         tubeRadiusAbsolute;
    private double         tubeRadiusBBox;
    private int            ribbonWidthSizeType;
    private double         ribbonWidthAbsolute;
    private double         ribbonWidthBBox;
    private int            lineWidth;
    private boolean        showSeeds;
    private int            seedRadiusSizeType;
    private double         seedRadiusAbsolute;
    private double         seedRadiusBBox;
    private boolean        showHeads;
    private int            headDisplayType;
    private int            headRadiusSizeType;
    private double         headRadiusAbsolute;
    private double         headRadiusBBox;
    private double         headHeightRatio;
    private int            opacityType;
    private String         opacityVariable;
    private double         opacity;
    private double         opacityVarMin;
    private double         opacityVarMax;
    private boolean        opacityVarMinFlag;
    private boolean        opacityVarMaxFlag;
    private int            tubeDisplayDensity;
    private int            geomDisplayQuality;
    private double         sampleDistance0;
    private double         sampleDistance1;
    private double         sampleDistance2;
    private boolean        fillInterior;
    private boolean        randomSamples;
    private int            randomSeed;
    private int            numberOfRandomSamples;
    private boolean        forceNodeCenteredData;
    private boolean        issueTerminationWarnings;
    private boolean        issueStiffnessWarnings;
    private boolean        issueCriticalPointsWarnings;
    private double         criticalPointThreshold;
    private int            varyTubeRadius;
    private double         varyTubeRadiusFactor;
    private String         varyTubeRadiusVariable;
    private double         correlationDistanceAngTol;
    private double         correlationDistanceMinDistAbsolute;
    private double         correlationDistanceMinDistBBox;
    private int            correlationDistanceMinDistType;
    private String         selection;
}

