import sys

class RPCType(object):
        CloseRPC = 0
        DetachRPC = 1
        AddWindowRPC = 2
        DeleteWindowRPC = 3
        SetWindowLayoutRPC = 4
        SetActiveWindowRPC = 5
        ClearWindowRPC = 6
        ClearAllWindowsRPC = 7
        OpenDatabaseRPC = 8
        CloseDatabaseRPC = 9
        ActivateDatabaseRPC = 10
        CheckForNewStatesRPC = 11
        CreateDatabaseCorrelationRPC = 12
        AlterDatabaseCorrelationRPC = 13
        DeleteDatabaseCorrelationRPC = 14
        ReOpenDatabaseRPC = 15
        ReplaceDatabaseRPC = 16
        OverlayDatabaseRPC = 17
        OpenComputeEngineRPC = 18
        CloseComputeEngineRPC = 19
        AnimationSetNFramesRPC = 20
        AnimationPlayRPC = 21
        AnimationReversePlayRPC = 22
        AnimationStopRPC = 23
        TimeSliderNextStateRPC = 24
        TimeSliderPreviousStateRPC = 25
        SetTimeSliderStateRPC = 26
        SetActiveTimeSliderRPC = 27
        AddPlotRPC = 28
        SetPlotFrameRangeRPC = 29
        DeletePlotKeyframeRPC = 30
        MovePlotKeyframeRPC = 31
        DeleteActivePlotsRPC = 32
        HideActivePlotsRPC = 33
        DrawPlotsRPC = 34
        DisableRedrawRPC = 35
        RedrawRPC = 36
        SetActivePlotsRPC = 37
        ChangeActivePlotsVarRPC = 38
        AddOperatorRPC = 39
        AddInitializedOperatorRPC = 40
        PromoteOperatorRPC = 41
        DemoteOperatorRPC = 42
        RemoveOperatorRPC = 43
        RemoveLastOperatorRPC = 44
        RemoveAllOperatorsRPC = 45
        SaveWindowRPC = 46
        SetDefaultPlotOptionsRPC = 47
        SetPlotOptionsRPC = 48
        SetDefaultOperatorOptionsRPC = 49
        SetOperatorOptionsRPC = 50
        WriteConfigFileRPC = 51
        ConnectToMetaDataServerRPC = 52
        IconifyAllWindowsRPC = 53
        DeIconifyAllWindowsRPC = 54
        ShowAllWindowsRPC = 55
        HideAllWindowsRPC = 56
        UpdateColorTableRPC = 57
        SetAnnotationAttributesRPC = 58
        SetDefaultAnnotationAttributesRPC = 59
        ResetAnnotationAttributesRPC = 60
        SetKeyframeAttributesRPC = 61
        SetPlotSILRestrictionRPC = 62
        SetViewAxisArrayRPC = 63
        SetViewCurveRPC = 64
        SetView2DRPC = 65
        SetView3DRPC = 66
        ResetPlotOptionsRPC = 67
        ResetOperatorOptionsRPC = 68
        SetAppearanceRPC = 69
        ProcessExpressionsRPC = 70
        SetLightListRPC = 71
        SetDefaultLightListRPC = 72
        ResetLightListRPC = 73
        SetAnimationAttributesRPC = 74
        SetWindowAreaRPC = 75
        PrintWindowRPC = 76
        ResetViewRPC = 77
        RecenterViewRPC = 78
        ToggleAllowPopupRPC = 79
        ToggleMaintainViewModeRPC = 80
        ToggleBoundingBoxModeRPC = 81
        ToggleCameraViewModeRPC = 82
        TogglePerspectiveViewRPC = 83
        ToggleSpinModeRPC = 84
        ToggleLockTimeRPC = 85
        ToggleLockToolsRPC = 86
        ToggleLockViewModeRPC = 87
        ToggleFullFrameRPC = 88
        UndoViewRPC = 89
        RedoViewRPC = 90
        InvertBackgroundRPC = 91
        ClearPickPointsRPC = 92
        SetWindowModeRPC = 93
        EnableToolRPC = 94
        SetToolUpdateModeRPC = 95
        CopyViewToWindowRPC = 96
        CopyLightingToWindowRPC = 97
        CopyAnnotationsToWindowRPC = 98
        CopyPlotsToWindowRPC = 99
        ClearCacheRPC = 100
        ClearCacheForAllEnginesRPC = 101
        SetViewExtentsTypeRPC = 102
        ClearRefLinesRPC = 103
        SetRenderingAttributesRPC = 104
        QueryRPC = 105
        CloneWindowRPC = 106
        SetMaterialAttributesRPC = 107
        SetDefaultMaterialAttributesRPC = 108
        ResetMaterialAttributesRPC = 109
        SetPlotDatabaseStateRPC = 110
        DeletePlotDatabaseKeyframeRPC = 111
        MovePlotDatabaseKeyframeRPC = 112
        ClearViewKeyframesRPC = 113
        DeleteViewKeyframeRPC = 114
        MoveViewKeyframeRPC = 115
        SetViewKeyframeRPC = 116
        OpenMDServerRPC = 117
        EnableToolbarRPC = 118
        HideToolbarsRPC = 119
        HideToolbarsForAllWindowsRPC = 120
        ShowToolbarsRPC = 121
        ShowToolbarsForAllWindowsRPC = 122
        SetToolbarIconSizeRPC = 123
        SaveViewRPC = 124
        SetGlobalLineoutAttributesRPC = 125
        SetPickAttributesRPC = 126
        ExportColorTableRPC = 127
        ExportEntireStateRPC = 128
        ImportEntireStateRPC = 129
        ImportEntireStateWithDifferentSourcesRPC = 130
        ResetPickAttributesRPC = 131
        AddAnnotationObjectRPC = 132
        HideActiveAnnotationObjectsRPC = 133
        DeleteActiveAnnotationObjectsRPC = 134
        RaiseActiveAnnotationObjectsRPC = 135
        LowerActiveAnnotationObjectsRPC = 136
        SetAnnotationObjectOptionsRPC = 137
        SetDefaultAnnotationObjectListRPC = 138
        ResetAnnotationObjectListRPC = 139
        ResetPickLetterRPC = 140
        SetDefaultPickAttributesRPC = 141
        ChooseCenterOfRotationRPC = 142
        SetCenterOfRotationRPC = 143
        SetQueryOverTimeAttributesRPC = 144
        SetDefaultQueryOverTimeAttributesRPC = 145
        ResetQueryOverTimeAttributesRPC = 146
        ResetLineoutColorRPC = 147
        SetInteractorAttributesRPC = 148
        SetDefaultInteractorAttributesRPC = 149
        ResetInteractorAttributesRPC = 150
        GetProcInfoRPC = 151
        SendSimulationCommandRPC = 152
        UpdateDBPluginInfoRPC = 153
        ExportDBRPC = 154
        SetTryHarderCyclesTimesRPC = 155
        OpenClientRPC = 156
        OpenGUIClientRPC = 157
        OpenCLIClientRPC = 158
        SuppressQueryOutputRPC = 159
        SetQueryFloatFormatRPC = 160
        SetMeshManagementAttributesRPC = 161
        SetDefaultMeshManagementAttributesRPC = 162
        ResetMeshManagementAttributesRPC = 163
        ResizeWindowRPC = 164
        MoveWindowRPC = 165
        MoveAndResizeWindowRPC = 166
        SetStateLoggingRPC = 167
        ConstructDataBinningRPC = 168
        RequestMetaDataRPC = 169
        SetTreatAllDBsAsTimeVaryingRPC = 170
        SetCreateMeshQualityExpressionsRPC = 171
        SetCreateTimeDerivativeExpressionsRPC = 172
        SetCreateVectorMagnitudeExpressionsRPC = 173
        CopyActivePlotsRPC = 174
        SetPlotFollowsTimeRPC = 175
        TurnOffAllLocksRPC = 176
        SetDefaultFileOpenOptionsRPC = 177
        SetSuppressMessagesRPC = 178
        ApplyNamedSelectionRPC = 179
        CreateNamedSelectionRPC = 180
        DeleteNamedSelectionRPC = 181
        LoadNamedSelectionRPC = 182
        SaveNamedSelectionRPC = 183
        SetNamedSelectionAutoApplyRPC = 184
        UpdateNamedSelectionRPC = 185
        InitializeNamedSelectionVariablesRPC = 186
        MenuQuitRPC = 187
        SetPlotDescriptionRPC = 188
        MovePlotOrderTowardFirstRPC = 189
        MovePlotOrderTowardLastRPC = 190
        SetPlotOrderToFirstRPC = 191
        SetPlotOrderToLastRPC = 192
        RenamePickLabelRPC = 193
        GetQueryParametersRPC = 194
        DDTConnectRPC = 195
        DDTFocusRPC = 196
        ReleaseToDDTRPC = 197
        MaxRPC = 198

