/*****************************************************************************
*
* Copyright (c) 2000 - 2014, Lawrence Livermore National Security, LLC
* Produced at the Lawrence Livermore National Laboratory
* LLNL-CODE-442911
* All rights reserved.
*
* This file is  part of VisIt. For  details, see https://visit.llnl.gov/.  The
* full copyright notice is contained in the file COPYRIGHT located at the root
* of the VisIt distribution or at http://www.llnl.gov/visit/copyright.html.
*
* Redistribution  and  use  in  source  and  binary  forms,  with  or  without
* modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of  source code must  retain the above  copyright notice,
*    this list of conditions and the disclaimer below.
*  - Redistributions in binary form must reproduce the above copyright notice,
*    this  list of  conditions  and  the  disclaimer (as noted below)  in  the
*    documentation and/or other materials provided with the distribution.
*  - Neither the name of  the LLNS/LLNL nor the names of  its contributors may
*    be used to endorse or promote products derived from this software without
*    specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT  HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR  IMPLIED WARRANTIES, INCLUDING,  BUT NOT  LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND  FITNESS FOR A PARTICULAR  PURPOSE
* ARE  DISCLAIMED. IN  NO EVENT  SHALL LAWRENCE  LIVERMORE NATIONAL  SECURITY,
* LLC, THE  U.S.  DEPARTMENT OF  ENERGY  OR  CONTRIBUTORS BE  LIABLE  FOR  ANY
* DIRECT,  INDIRECT,   INCIDENTAL,   SPECIAL,   EXEMPLARY,  OR   CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT  LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR
* SERVICES; LOSS OF  USE, DATA, OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER
* CAUSED  AND  ON  ANY  THEORY  OF  LIABILITY,  WHETHER  IN  CONTRACT,  STRICT
* LIABILITY, OR TORT  (INCLUDING NEGLIGENCE OR OTHERWISE)  ARISING IN ANY  WAY
* OUT OF THE  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
* DAMAGE.
*
*****************************************************************************/

// ************************************************************************* //
//                             avtDO_REPL_STRING.h                           //
// ************************************************************************* //

#ifndef AVT_DO_REPL_STRING_H
#define AVT_DO_REPL_STRING_H

#include <pipeline_exports.h>


#include <ref_ptr.h>

#include <avtDataObject.h>


// ****************************************************************************
//  Class: avtDO_REPL_STRING
//
//  Purpose:
//      This defines the DO_REPL_STRING data object.
//
//  Programmer: autogenerated by AUTHOR_REPL_STRING
//  Creation:   DATE_REPL_STRING
//
// ****************************************************************************

class PIPELINE_API avtDO_REPL_STRING : public avtDataObject
{
    friend class              avtDO_REPL_STRINGSink;
    friend class              avtDO_REPL_STRINGSource;

  public:
                              avtDO_REPL_STRING(avtDataObjectSource *);
    virtual                  ~avtDO_REPL_STRING();

    virtual const char       *GetType(void)  { return "avtDO_REPL_STRING"; };
    virtual avtDataObject    *Instance(void);
    virtual int               GetNumberOfCells(bool) const;

    /* You will need to implement this if you want your data object to be 
     * passed from the server to the client.

    virtual avtDataObjectWriter
                             *InstantiateWriter(void);
     */

    virtual void              ReleaseData(void);

  protected:
    YOUR DATA OBJECTS GO HERE

    virtual void              DerivedCopy(avtDataObject *);
};


typedef ref_ptr<avtDO_REPL_STRING>  avtDO_REPL_STRING_p;


#endif


